/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

dojo.provide("ibm_ilog.diagram.ibm_ilog.diagram_editing");
if(!dojo._hasResource['ibm_ilog.diagram.layer_editing_dojo_requires']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.layer_editing_dojo_requires'] = true;
dojo.provide('ibm_ilog.diagram.layer_editing_dojo_requires');

dojo["require"]('dojo.dnd.Source');
dojo["require"]('dojox.collections.Dictionary');
dojo["require"]('dojox.gfx.matrix');

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ComponentAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ComponentAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ComponentAdorner');





(function() {

	var g = ibm_ilog.diagram.util.Geometry,	Rect = g.Rect,	EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var m = dojox.gfx.matrix;

	var __invisibleLocation = Rect(ibm_ilog.diagram._invisibleLocation, ibm_ilog.diagram._invisibleLocation, ibm_ilog.diagram._invisibleSize, ibm_ilog.diagram._invisibleSize);

var cls = ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ComponentAdorner', [ibm_ilog.diagram.adorners.Adorner], {

	//	summary:
	//		An adorner for adorning components of Graph elements. 
	//
		
	//
	// _component: dojox.gfx.Shape
	//
	_component: null,
	
	//
	//	_componentBounds: dojox.gfx.Rect
	//
	_componentBounds: null,
	
	
	setComponent: function( /*Shape|string|null*/ component ) {
		//
		// 	summary:
		//		Sets the attachPoint name of visual shape associated with the property. 
		//		If null the whole element shape is asummed.
		//
		if(component && dojo.isString(component)) {
			this._component = this[component];
		} else {
			this._component = component;
		}
	},

	getComponent: function() {
		//
		//	summary:
		//		Returns the attachPoint name of the visual shape associated with the property. 
		//
		return this._component;
	},
	
	_computeElementBoundsChanged: function () {
		//
		//	summary:
		//		Recomputes the geometric values published to the template (adds 
		//		property component bounds to the values already computed in the 
		//		superclass)   
		//
	  var c,bb;
	  // compute component bounds	  
	  if(this._component && this._required() ) {
			c = this._component;
			  
			bb = c.getBoundingBox();
			if(bb) { // gfx does not support this properly, some renderers may fail. Fallback to node BB
				var pm = this._diagram.getGraph()._getRealMatrix().inverse();
				var cm = c.getParent()._getRealMatrix() || m.identity;
				var t = m.multiply(pm,cm);
				this._componentBounds = t.transformRectangle(bb);
		  } else {
		  	this._componentBounds = null;
		  }
	  } else {
	  	this._componentBounds = null;
	  }
	  this.inherited(arguments);
	},
	
	_updateLayout: function() {
		//
		//	summary:
		//		Publish new geometric values (causes template bindings to be applied if changed).
		//
		
		this.startDTLBatch();

		this.inherited(arguments);
		
		// also publish component-related coords (fallback to element coords if not present)
		
		var bb = __invisibleLocation;
		if (this._adorned) {
			bb = this._viewport.contentToClient().transformRectangle(this._componentBounds || this._elementBounds);
		}
		this.setCompWidth(bb.width);
		this.setCompHeight(bb.height);
		this.setCompRight(bb.x + bb.width);
		this.setCompBottom(bb.y + bb.height);
		this.setCompLeft(bb.x);
		this.setCompTop(bb.y);
		this.setCompCenterX(bb.width / 2);
		this.setCompCenterY(bb.height / 2);
		
		this.endDTLBatch();
	}
	
}));

ibm_ilog.diagram.templating.declareBindableProperty(cls, "compLeft", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compTop", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compBottom", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compRight", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compWidth", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compHeight", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compCenterX", null);
ibm_ilog.diagram.templating.declareBindableProperty(cls, "compCenterY", null);

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor');






(function () {
	var g = ibm_ilog.diagram.util.Geometry;
	var gu = ibm_ilog.diagram.util.GraphUtil;

dojo.declare("ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor", [ibm_ilog.diagram.interactors.Interactor], {

	_handle: null,
	_viewport: null,

	initialize: function ( /* ibm_ilog.diagram.editor.ConnectionHandle */ connectionHandle) {
		this._handle = connectionHandle;
		this._viewport = connectionHandle.getViewport();
		this._initialize();
		return this;
	},

	_declareStates: function () {
		this._declareState("idle", ["onMouseRealease"]);
	},

	getDefaultConnections: function () {
		//
		//	summary:
		//		returns the default event mapping
		//
		return {
			onMouseRealease: {
				src: this._getInitialEventSource(),
				srcEvt: "onmouseup",
				connectTo: "_setTarget",
				gfxConnect: true
			}
		};
	},
	
	_getInitialEventSource: function () {
		return this._handle;
	},

	_setTarget: function (ge, e) {
		this._handle.getConnectionInteractor().setPortPosition(this._handle.getPortPosition());
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle');





(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		
		//
		//	_location: Point
		//
		location: null,
		connectionInteractor: null,
		setup: function(location) {
			this.location = location;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor().initialize(this));
			return this;
		},
		setConnectionInteractor: function(connectionInteractor){
			this.connectionInteractor = connectionInteractor;
		},	
		getConnectionInteractor:function(){
			return this.connectionInteractor;
		},
		getPortPosition:function(){
			return this.location;
		}
	}));
	
	
	
	ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle.templateId = "ConnectionTargetHandle";


})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner');





(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
    
	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner',[ibm_ilog.diagram.adorners.AdornerWithHandles],{

    	initialize: function() {
    		this.inherited(arguments);

    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndT").setup(Point(0.5,0));
    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndR").setup(Point(1,0.5));
    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndB").setup(Point(0.5,1));
    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndL").setup(Point(0,0.5));
    	},
    
    	setConnectionInteractor: function(connectionInteractor){
    		this["hndT"].setConnectionInteractor(connectionInteractor);
    		this["hndR"].setConnectionInteractor(connectionInteractor);
    		this["hndB"].setConnectionInteractor(connectionInteractor);
    		this["hndL"].setConnectionInteractor(connectionInteractor);
    	},
    	
    	activate: function() {
    		this._activateHandle("hndT");
    		this._activateHandle("hndR");
    		this._activateHandle("hndB");
    		this._activateHandle("hndL");
    	},
    	
    	deactivate: function() {
    		this._deactivateHandle("hndT");
    		this._deactivateHandle("hndR");
    		this._deactivateHandle("hndB");
    		this._deactivateHandle("hndL");
    	}

    }));

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionTargetInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionTargetInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ConnectionTargetInteractor');






(function () {
	var g = ibm_ilog.diagram.util.Geometry;
	var gu = ibm_ilog.diagram.util.GraphUtil;

dojo.declare("ibm_ilog.diagram.editor.interactors.ConnectionTargetInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//
	//	summary:
	//		A ConnectionTargetInteractor controls the process of selecting the target Connection point
	//		This feature has a low cpu usage alternative. (set in the diagram)
	//
	//
	//	_viewport: ibm_ilog.diagram.widget.Viewport
	//		The diagram viewport 
	//
	_viewport: null,

	//
	//	_diagram: ibm_ilog.diagram.widget.Diagram
	//		The diagram to pan
	//
	_diagram: null,

	_targetIsFree: true,

	_target: null,

	_targetAdorner: null,

	_margin: 12,

	_fixedNode: null,
	_isStart: true,
	_standardCursor: null,
	_forbiddenCursor: "not-allowed",
	_allowedCursor: "crosshair",
	_connectionInteractor: null,
	_lowCpuMode: null,
	_lastPosition: null,

	initialize: function ( /*ibm_ilog.diagram.widget.Diagram*/ diagram, connectionInteractor) {
		this._diagram = diagram;
		this._viewport = diagram.getViewport();
		this._targetIsFree = true;
		this._target = null;
		this._connectionInteractor = connectionInteractor;
		this._targetAdorner = diagram.createAdorner(ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner, this._diagram._adornerTemplates, "ConnectionAdorner");
		this._targetAdorner.setConnectionInteractor(connectionInteractor);
		this._initialize();
		return this;
	},

	setUp: function (node, isStart, allowFreeLinks) {
		this._fixedNode = node;
		this._isStart = isStart;
		this._allowFreeLinks = allowFreeLinks;
		if(this._lowCpuMode != this._diagram.isLowCpuMode()){
			this._lowCpuMode = this._diagram.isLowCpuMode();
			this.deactivate();
			this._initialize();
		}
		this._lastPosition = {x:0, y:0};
	},

	_declareStates: function () {
		if(this._lowCpuMode == true){
			this._declareState("idle", ["nodeover", "subgraphover", "testfreetarget"]);
		}else{
			this._declareState("idle", ["detectOnOver"]);
		}
	},

	getDefaultConnections: function () {
		//
		//	summary:
		//		returns the default event mapping
		//
		if(this._lowCpuMode == true){
			return {
				nodeover: {
					src: this._diagram,
					srcEvt: "onNodeMouseOver",
					connectTo: "_setTarget"
				}, subgraphover: {
					src: this._diagram,
					srcEvt: "onSubgraphMouseOver",
					connectTo: "_setTarget"
				}, testfreetarget: {
					src: this._viewport.getEventSource(),
					srcEvt: "onmousemove",
					connectTo: "_testFreeTarget",
					gfxConnect: true
				}
				};
				
		}else{
						return {
				detectOnOver: {
					src: this._viewport.getEventSource(),
					srcEvt: "onmousemove",
					connectTo: "_detectOnOver",
					gfxConnect: true
				}
				};
		}
	},

	_setTarget: function (ge, e) {
		if (this._targetIsFree || gu.isContainedBy(ge, this._target)) {
			var start, end;
			if (this._isStart) {
				start = this._fixedNode;
				end = ge;
			} else {
				end = this._fixedNode;
				start = ge;
			}
			var D = this._diagram;
			if (!D.allowCreateLink(start, end)) {
				D.domNode.style.cursor = this._forbiddenCursor;
			} else {
				D.domNode.style.cursor = this._allowedCursor;
			}
			this._setTargetAdorner(ge);
			this._targetIsFree = false;
			//dojo.stopEvent(e);
		}
	},

	_setTargetAdorner: function (ge) {
		this._target = ge;
		this._targetAdorner.setAdorned(ge);
		this._connectionInteractor.setTarget(ge);
	},

	activate: function () {
		this.inherited(arguments);
		this._standardCursor = dojo.isIE ? "default" : this._diagram.domNode.style.cursor;
		this._setFreeCursor();
	},

	deactivate: function () {
		this.inherited(arguments);
		this._freeTarget();
		this._diagram.domNode.style.cursor = this._standardCursor;
	},

	_freeTarget: function (e) {
		if (!this._targetIsFree) {
			this._targetAdorner.setAdorned(null);
			this._connectionInteractor.setTarget(null);
		}
		this._targetIsFree = true;
		this._target = null;
		this._setFreeCursor();
	},

	_testFreeTarget: function (e) {
		if (!this._targetIsFree) {
			var c = this._target;
			if (c) {
				var bb = g.expandRect(c.getBounds(this._viewport.getSurface()), this._margin);
				var l = this._viewport.eventClientLocation(e);
				if (!g.containsPoint(bb, l)) {
					this._freeTarget();
				}
			}
		}
	},
	_setFreeCursor: function () {
		if (this._allowFreeLinks) {
			this._diagram.domNode.style.cursor = this._allowedCursor;
		} else {
			this._diagram.domNode.style.cursor = this._forbiddenCursor;
		}
	},
	_detectOnOver: function (e) {
		//added to increase performance
		var current = {x:e.pageX, y:e.pageY};
		var delta = {
				x: Math.abs(current.x - this._lastPosition.x),
				y: Math.abs(current.y - this._lastPosition.y)
			};
		var minDelta = 2;
		if(delta.x<minDelta && delta.y<minDelta){
			return;
		}
		
		this._testFreeTarget(e);	
		var p = this._viewport.eventContentLocation(e);
		var ges = this._diagram.getGraph().hitTest(p,0);
		for (var index in ges){
			var ge = ges[index];
			if(ge._isIBMDiagramNode || ge._isIBMDiagramSubgraph){
				this._setTarget(ge,e);
				break;
			}
		}
		
		this._lastPosition = {x:current.x, y:current.y};
		
	}

});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionHandleInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionHandleInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ConnectionHandleInteractor');










(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;
	var gu = ibm_ilog.diagram.util.GraphUtil;
	
dojo.declare("ibm_ilog.diagram.editor.interactors.ConnectionHandleInteractor", [ibm_ilog.diagram.interactors.DragInteractor], {

	//	_handle: /*ibm_ilog.diagram.editor.adorners.ConnectionHandle*/
	_handle:null,
	_link:null,
	_linkShapeType: ibm_ilog.diagram.LinkShapeType.Straight,
	_automaticPortType: false,
	_allowFreeLinks: false,
	_target: null,
	_targetPosition: null,
	
	_targetInteractor: null,
	
	_declareStates: function() {
	// Summary:
	//		Add the crtl start to the original states
		this.inherited(arguments);	
		this._declareState("idle",["start","startCtrl"]);
	},
	
	getDefaultConnections:function(){
		//
		//	summary:
		//		returns the default event mapping
		//
    		var map = this.inherited(arguments);
    		map.startCtrl = {src:this._getInitialEventSource(),srcEvt:"onmousedown",connectTo:"_dragCrtlPreStart",filter:this._buildInputFilter({ctrl:true,button:0}), gfxConnect:true};
    		return map;
    },
	
	initialize: function( /* ibm_ilog.diagram.editor.ConnectionHandle */ connectionHandle ) {
		this._handle = connectionHandle;
		this._viewport = connectionHandle.getViewport();
		var linkStyle = this._viewport.getDiagram().linkStyle;
		this._linkShapeType = linkStyle?linkStyle.shapeType:ibm_ilog.diagram.LinkShapeType.Straight;
		this._targetInteractor = new ibm_ilog.diagram.editor.interactors.ConnectionTargetInteractor().initialize(this._handle._adorner._viewport._diagram,this);
		this._initialize();
		return this;
	},
	
	setTarget: function(target){
		// Summary:
		//		sets the target node that will be the end node of the new link.
		//		this function is called by the ConnectionTargetInteractor
		this._target = target;
	},
	
	setPortPosition: function(position){
		// Summary:
		//		sets the target port position that will be the end port position of the new link.
		//		this function is called by the ConnectionTargetHandleInteractor
		this._targetPosition = position;
	},
	
	setAllowFreeLinks: function(allowFreeLinks){
		// Summary:
		//		controls if the free links (links with no final nodes) are allowed
		this._allowFreeLinks = allowFreeLinks;
	},
	
	setLinkShapeType: function(linkShapeType){
		// Summary:
		//		sets the link shape type
		this._linkShapeType = linkShapeType;
	},
	
	_getInitialEventSource: function() {
		return this._handle;
	},
	
	_dragCrtlPreStart: function(e) {
		this._dragPreStart(e);
		this._automaticPortType = true;
	},
	
    _dragPreStart: function(e) {
		this._allowFreeLinks = this._viewport.getDiagram().getAllowFreeLinks();
		this._handle.interactionBegun(this);
		this._automaticPortType = false;
		this.inherited(arguments);
	},
	
	_dragMove: function(e) {
    	this.inherited(arguments);
		
    	var A = this._handle._adorner;
    	var V = A._viewport;
    	var D = V.getDiagram();
		if( this._link == null ){
			this._targetPosition = null;
			this._link = D.createTemplatedShape(ibm_ilog.diagram.Link, ibm_ilog.diagram.Link.defaultTemplate, D.getGraph());
			//this._link = D.createLinkShape(D.getGraph());
			var startPort = this._createPort(this._automaticPortType,this._handle.getPortPosition());
			var start = A._adorned;
			start.addPort(startPort);
			this._link.setStartPort(startPort);
			this._link.setShapeType(this._linkShapeType);
			this._targetInteractor.setUp(start,true,this._allowFreeLinks);
			this._targetInteractor.activate();
		}
		
		var point = V.eventContentLocation(e);
		var t = D.getGraph().getShapeToContainerTransform(D.getGraph().getParent()).inverse();
		point = t.transformPoint(point);
		this._link.setFallbackEndPoint(point);
		
		this._link.validateLinkShape();
	},

	_dragEnd: function(e) {
		this.inherited(arguments);
		var A = this._handle._adorner;
		var V = A._viewport;
		var D = V._diagram;
		
		if( this._link != null ){
			if(this._target){
				var endPort = this._createPort(false,this._targetPosition);
				var start = this._link.getStartNode();
				var end = this._target;
				if(D.allowCreateLink(start,end)){
					end.addPort(endPort);
					this._link.setEndPort(endPort);
					//reparent the link, with the lower common parent
					var cParent = gu.lowestCommonAncestor(start,end);
					cParent.add(this._link);
					var undoAction = this._createUndoAction(D,this._link,cParent);
					D._onLinkCreated(this._link,start,end,D);
					D.onLinkUpdated(D,this._link,true,undoAction);
					if(D._isIBMDiagramEditor){
						D.getUndoManager().addAction(undoAction);
					}
					this._link.validateLinkShape();
				}else{
					D.getGraph().remove(this._link);
					this._link.dispose();
					//TODO add onMessage call
				}
			}else{
				if(!this._allowFreeLinks){
					D.getGraph().remove(this._link);
					this._link.dispose();
					//TODO add onMessage call
				}else{
					var undoAction = null;
					if(D._isIBMDiagramEditor){
						undoAction = this._createUndoAction(D,this._link,D.getGraph());
						D.getUndoManager().addAction(undoAction);
					}
					D.onLinkCreated(this._link,this._link.getStartNode(),null,D);
					D.onLinkUpdated(D,this._link,true,undoAction);
				}
			}
			
			this._link =null;
			this._targetInteractor.deactivate();
		}
		this._handle.interactionEnded(this);
	},
	
	_createPort: function(automaticPortType,position){
		var port;
		if(automaticPortType || !position){
			port = new ibm_ilog.diagram.AutomaticPort();
		}else{
			port = new ibm_ilog.diagram.BasicPort();
			port.setPosition(position);
		}
		return port;
	},
	_createUndoAction: function(diagram,link,parent){
		var action = new ibm_ilog.diagram.editor.undo.ConnectAction(diagram,link,parent);
		return action;
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionHandle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionHandle'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ConnectionHandle');





(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ConnectionHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		
		//
		//	_location: Point
		//
		location: null,
		
		setup: function(location) {
			this.location = location;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.ConnectionHandleInteractor().initialize(this));
			return this;
		},
		
		getPortPosition:function(){
			return this.location;
		}
	}));
	
	ibm_ilog.diagram.editor.adorners.ConnectionHandle.templateId = "ConnectionHandle";


})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ConnectionAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ConnectionAdorner');





(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
    
	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ConnectionAdorner',[ibm_ilog.diagram.adorners.AdornerWithHandles],{

    	initialize: function() {
    		this.inherited(arguments);

    		this._createConnectionHandle("hndT",Point(0.5,0));
    		this._createConnectionHandle("hndR",Point(1,0.5));
    		this._createConnectionHandle("hndB",Point(0.5,1));
    		this._createConnectionHandle("hndL",Point(0,0.5));
    	},
        
    	_createConnectionHandle: function(attachPoint,p) {
    		var h = this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionHandle,attachPoint);
    		if(h) {
    			h.setup(p);
    		}
    	}

    }));

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.undo.ReConnectAction']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.undo.ReConnectAction'] = true;
dojo.provide('ibm_ilog.diagram.editor.undo.ReConnectAction');





(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	
	dojo.declare("ibm_ilog.diagram.editor.undo.ReConnectAction", [ibm_ilog.diagram.editor.undo.UserCustomizedAction], {
		//	
		// summary:
		//		this action undo/redo any ReConnect action.
		//		This action must be modified for the user if any user defined action is done on a ReConnect action.
		//
		_linkId: null,
		_applyConnectionFunction: null,
		_createPortFunction: null,
		_oldConnection: null,
		_newConnection: null,
		_portPosition: null,
	
	constructor:function(diagram,link,position,savedConnection,newConnection,createPort,applyConnection){
		
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.ReConnect;
		this._linkId = link.getId();
		this._portPosition = position;
		this._createPortFunction = dojo.hitch(this,createPort);
		this._applyConnectionFunction = dojo.hitch(this,applyConnection);
		
		savedConnection.nodeId = savedConnection.node?savedConnection.node.getId():null;
		savedConnection.node = null;
		this._oldConnection = savedConnection;
		
		newConnection.nodeId = newConnection.node?newConnection.node.getId():null;
		newConnection.node = null;
		this._newConnection = newConnection;
	},
	_clearPort: function(){
		var port;
		var link = this.getUndoManager().getRegisteredGraphElement(this._linkId);
		if(this._portPosition == 0){
			port = link.getStartPort();
			link.setStartPort(null);
		}else{
			port = link.getEndPort();
			link.setEndPort(null);
		}
		//remove Port
		if(port && port._isIBMDiagramBasicPort){
			port.getOwner().removePort(port);
		}
	},
	getLink: function(){
		// Summary:
		//		return the link modified (verifying replaces)
		return this.getUndoManager().getRegisteredGraphElement(this._linkId);
	},
	isStartModified: function(){
		// Summary:
		//		return true if the start of the link is the modified component.
		return this._portPosition == 0;
	},
	undoFunction: function(){
		var link = this.getLink();
		var node = this.getUndoManager().getRegisteredGraphElement(this._oldConnection.nodeId);
		this._oldConnection.nodeId = node.getId();
		this._clearPort.call(this);
		this._oldConnection.node = node;
		this._applyConnectionFunction.call(null,link,this._portPosition,this._oldConnection,this._createPortFunction);
		this._oldConnection.node = null;
		var D = this.getUndoManager().getDiagram();
		D.onLinkUpdated(D,link,false,this);
	},
	
	redoFunction: function(){
		var link = this.getLink();
		var node = this.getUndoManager().getRegisteredGraphElement(this._newConnection.nodeId);
		this._newConnection.nodeId = node?node.getId():null;
		this._clearPort.call(this);
		this._newConnection.node = node;
		this._applyConnectionFunction.call(null,link,this._portPosition,this._newConnection,this._createPortFunction);
		this._newConnection.node = null;
		var D = this.getUndoManager().getDiagram();
		D.onLinkUpdated(D,link,false,this);
	}
	});
	
})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.undo.ReparentingAction']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.undo.ReparentingAction'] = true;
dojo.provide('ibm_ilog.diagram.editor.undo.ReparentingAction');






(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	
	dojo.declare("ibm_ilog.diagram.editor.undo.ReparentingAction", [ibm_ilog.diagram.editor.undo.Action], {
		//
		//	summary:
		//		this action undo / redo a reparenting action.
		_newParentId: null,
		_oldParentId: null,
		_modifiedElementId: null,
	
	constructor:function(){
		//	
		// summary:
		//		creates a new instance, setting the corresponding label
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.ReParent;
		this.initialize(dojo.hitch(this,this._undoFunction),dojo.hitch(this,this._redoFunction));
	},
	setNewParentId: function(newParentId){
		//	
		// summary:
		//		sets the new parent Id
		this._newParentId = newParentId;
	},
	setOldParentId: function(oldParentId){
		//	
		// summary:
		//		sets the old parent Id
		this._oldParentId= oldParentId;
	},
	setModifiedElementId: function(modifiedElementId){
		//	
		// summary:
		//		sets the modified element Id
		this._modifiedElementId= modifiedElementId;
	},
	_undoFunction: function(){
		var modifiedElement = this.getUndoManager().getRegisteredGraphElement(this._modifiedElementId);
		var oldParent = this.getUndoManager().getRegisteredParent(this._oldParentId);
		oldParent.add(modifiedElement);
	},
	_redoFunction: function(){
		var modifiedElement = this.getUndoManager().getRegisteredGraphElement(this._modifiedElementId);
		var newParent = this.getUndoManager().getRegisteredParent(this._newParentId);
		newParent.add(modifiedElement);
	}
	});
	
})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.LinkConnectionHandleInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.LinkConnectionHandleInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.LinkConnectionHandleInteractor');















(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;
	var gu = ibm_ilog.diagram.util.GraphUtil;

dojo.declare("ibm_ilog.diagram.editor.interactors.LinkConnectionHandleInteractor", [ibm_ilog.diagram.interactors.DragInteractor], {

	//	_handle: /*ibm_ilog.diagram.editor.ConnectionHandle*/
	_handle:null,
	_automaticPortType: false,
	_target: null,
	_targetPosition: null,
	_targetInteractor: null,
	_allowFreeLinks: false,
	_link: null,
	_savedConnection: null,
	_oldLinkParent: null,
	
	initialize: function( /* ibm_ilog.diagram.editor.ConnectionHandle */ connectionHandle ) {
		this._handle = connectionHandle;
		this._viewport = connectionHandle.getViewport();
		this._targetInteractor = new ibm_ilog.diagram.editor.interactors.ConnectionTargetInteractor().initialize(this._handle._adorner._viewport._diagram,this);
		this._initialize();
		return this;
	},
	
	setTarget: function(target){
		// Summary:
		// 		sets the target to be binded with the link 
		this._target = target;
	},
	
	setPortPosition: function(position){
		// Summary:
		//		sets the port position where to bind the link
		this._targetPosition = position;
	},
	_getInitialEventSource: function() {
		return this._handle;
	},

    _dragPreStart: function() {
		this._allowFreeLinks = this._viewport.getDiagram().getAllowFreeLinks();
		this._handle.interactionBegun(this);
		this.inherited(arguments);
	},
	
	_dragMove: function(e) {
    	
		this.inherited(arguments);
		
    	var A = this._handle._adorner;
    	var V = A._viewport;
    	var portPosition = this._handle.getLocation();

		if( this._link == null ){
			this._link = A._adorned;
			this._targetPosition = null;
			var fixedNode,isStart;
			
			var port,point;
			if(portPosition == 0){
				port= this._link.getStartPort();
				point= this._link.getFallbackStartPoint();
				this._link.setStartPort(null);
				fixedNode = this._link.getEndNode();
				isStart = false;
			}else{
				port= this._link.getEndPort();
				point= this._link.getFallbackEndPoint();
				this._link.setEndPort(null);
				fixedNode = this._link.getStartNode();
				isStart = true;
			}
			
			//Save unused port data
			if(port){
				this._savedConnection = {
					auto: !port._isIBMDiagramBasicPort,
					position: port._isIBMDiagramBasicPort?port.getPosition():null,
					node: port.getOwner()	
				};
			}else{
				this._savedConnection = {
						point: dojo.clone(point)
				};
			}
			
			//remove unused Port
			if(port && port._isIBMDiagramBasicPort){
				port.getOwner().removePort(port);
			}
			
			//Set the top level parent
			this._oldLinkParent = this._link.getParent();
			V.getDiagram().getGraph().add(this._link);
			this._targetInteractor.setUp(fixedNode,isStart,this._allowFreeLinks);
			this._targetInteractor.activate();
		}
		
		var point = V.eventContentLocation(e);
		var t = this._link.getShapeToContainerTransform(V._diagram.getGraph().getParent()).inverse();
		point = t.transformPoint(point);
		
		if(portPosition == 0){
			point = this._displacePoint(point,this._link,true);
			this._link.setFallbackStartPoint(point);
		}else{
			point = this._displacePoint(point,this._link,false);
			this._link.setFallbackEndPoint(point);
		}
		
		this._link.validateLinkShape();
	},

	_dragEnd: function(e) {
		this.inherited(arguments);
		var A = this._handle._adorner;
		var V = A._viewport;
		var D = A._diagram;
		var portPosition = this._handle.getLocation();
		if( this._link != null ){
			if(this._target){
				var connection = {auto:this._automaticPortType,
								  position: this._targetPosition,
								  node: this._target};
				
				this._applyConnection(this._link,portPosition,connection,this._createPort);
				
				//reparent the link, with the lower common parent
				var start = this._link.getStartPort().getOwner();
				var end = this._link.getEndPort().getOwner();
				if(D.allowCreateLink(start,end)){
					var cParent = gu.lowestCommonAncestor(start,end);
					if(cParent!=this._oldLinkParent){
						cParent.add(this._link);
					}
					var action = this._createUndoReConnectionAction(D,this._link,cParent,this._oldLinkParent,portPosition,this._savedConnection,connection);
					D.onLinkUpdated(D,this._link,false,action);
					if(D._isIBMDiagramEditor){
						D.getUndoManager().addAction(this._createUndoAction(D,this._link,cParent,this._oldLinkParent,action));
					}
				}else{
					this._applyConnection(this._link,portPosition,this._savedConnection,this._createPort);
					//TODO add onMessage call
				}
			}else{
				if(!this._allowFreeLinks){
					this._applyConnection(this._link,portPosition,this._savedConnection,this._createPort);
					//TODO add onMessage call
				}else{
					var action = this._createUndoReConnectionAction(D,this._link,this._link.getParent(),this._oldLinkParent,portPosition,this._savedConnection,connection);
					D.onLinkUpdated(D,this._link,false,action);
					if(D._isIBMDiagramEditor){
						var connection = {point:dojo.clone(portPosition==0?this._link.getFallbackStartPoint():this._link.getFallbackEndPoint())};
						D.getUndoManager().addAction(this._createUndoReConnectionAction(D,this._link,this._link.getParent(),this._oldLinkParent,action));
					}
				}
			}
			
			this._savedPort = null;
			this._link =null;
			this._targetInteractor.deactivate();
		}
		this._handle.interactionEnded(this);
	},
	
	_displacePoint: function(point,link,isStart){
		// Added to fix requirement 642
		var p;
		if(!isStart){
			p = link._pathPoints[link._pathPoints.length-1];
		}else{
			p = link._pathPoints[0];
		}
		var dx = (point.x-p.x)<0?5:-5;
		var dy = (point.y-p.y)<0?5:-5;
		return {x: point.x+dx, y: point.y+dy};
	},
	
	_applyConnection: function(link,portPosition,connection,portFunction){
		var port;
		if(connection.node){
			port = portFunction.call(this,connection.auto,connection.position);
			connection.node.addPort(port);
		}
		if(portPosition == 0){
			if(port){
				link.setStartPort(port);
			}else{
				link.setFallbackStartPoint(dojo.clone(connection.point));
			}
		}else{
			if(port){
				link.setEndPort(port);
			}else{
				link.setFallbackEndPoint(dojo.clone(connection.point));
			}
		}
	},
	
	_createPort: function(automaticPortType,position){
		var port;
		if(automaticPortType || !position){
			port = new ibm_ilog.diagram.AutomaticPort();
		}else{
			port = new ibm_ilog.diagram.BasicPort();
			port.setPosition(position);
		}
		return port;
	},
	_createUndoReConnectionAction: function(diagram,link,newParent,oldParent,position,savedConnection,newConnection){
		var action = new ibm_ilog.diagram.editor.undo.ReConnectAction(diagram,link,position,savedConnection,newConnection,this._createPort,this._applyConnection);
		return action;
	},
	_createUndoAction: function(diagram,link,newParent,oldParent,action){
		
		if(oldParent!=newParent){
			var reParentAction = new ibm_ilog.diagram.editor.undo.ReparentingAction();
			reParentAction.setOldParentId(diagram.getUndoManager().getParentId(oldParent));
			reParentAction.setNewParentId(diagram.getUndoManager().getParentId(newParent));
			reParentAction.setModifiedElementId(link.getId());
			var mAction = new ibm_ilog.diagram.editor.undo.MultipleAction(ibm_ilog.diagram.editor.undo.UndoActionList.ReConnect);
			mAction.addAction(action);
			mAction.addAction(reParentAction);
			return mAction;
		}else{
			return action;
		}
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkConnectionHandle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkConnectionHandle'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.LinkConnectionHandle');





(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkConnectionHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		
		//
		//	location: handle position
		//
		location: null,
		
		setup: function(location) {
			// Summary:
			//		sets the handle positioning ( 0=start - 1=end )
			this.location = location;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.LinkConnectionHandleInteractor().initialize(this));
			return this;
		},
		
		getLocation:function(){
			return this.location;
		}
	}));

	ibm_ilog.diagram.editor.adorners.LinkConnectionHandle.templateId = "LinkConnectionHandle";


})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkConnectionAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkConnectionAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.LinkConnectionAdorner');





(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
    
	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkConnectionAdorner',[ibm_ilog.diagram.adorners.LinkAdorner],{

    	initialize: function() {
    		this.inherited(arguments);

    		this._createHandle(ibm_ilog.diagram.editor.adorners.LinkConnectionHandle,"start").setup(0);
    		this._createHandle(ibm_ilog.diagram.editor.adorners.LinkConnectionHandle,"end").setup(1);

    	},
    	
    	activate: function() {
    		this._activateHandle("start");
    		this._activateHandle("end");
    	},
    	
    	deactivate: function() {
    		this._deactivateHandle("start");
    		this._deactivateHandle("end");
    	}

    }));

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor');






(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;

dojo.declare("ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	// summary:
	//		this interactor is created in the LinkIntermediatePointAdorner and have the functionality 
	//		to add intermediate points to the adorned link
	
	
	//	_handle: /*LinkIntermediatePointsHandle*/
	_handle: null,
	_viewport: null,
	
	_declareStates: function () {
		this._declareState("idle", ["add"]);
		//this._declareState("active", ["end"]);
	},

	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			add: {
				src: this._getInitialEventSource(),
				srcEvt: "onmousedown",
				connectTo: "_addIntermediatePoint",
				filter: this._buildInputFilter({shift:false,button:0}),
				gfxConnect:true
			}
		};
	},
	
	initialize: function( /* LinkIntermediatePointsHandle */ handle ) {
    	// Summary:
		//		sets the LinkIntermediatePointsHandle
    	this._handle = handle;
		this._viewport = handle.getViewport();
		this._initialize();
		return this;
	},
	
	_getInitialEventSource: function() {
		return this._handle;
	},
	
	_addIntermediatePoint: function(e) {
		// summary:
		//		Add the intermediate point to the adorned link
		var A = this._handle.getAdorner();
		var D = A.getDiagram();
		var link = A.getAdorned();
		var index = this._handle.getIndex();
		var point = this._getPoint(link,index);
		ibm_ilog.diagram.editor.EditingUtils.addItermediatePoint(D,link,point,index);
		A.rebindAdorned();
		dojo.stopEvent(e);
	},
	
	_getPoint: function(link,index){
		var iPoints = link._pathPoints;
		var p1 = iPoints[index];
		var p2 = iPoints[index+1];
		var point = {x:((p2.x-p1.x)/2+p1.x), y:((p2.y-p1.y)/2+p1.y)};
		return point;
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle');





(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		// Summary:
		//		this class is the handle that manage the link intermediate points. 
		//		Contains the instance of LinkIntermediatePointsHandleInteractor that enables to remove and edit these points.
		
		//
		//	_location: handle position
		//
		_isAddHandle : true,
		_index: null,
		setUp: function(index) {
		// Summary:
		//		sets the handle Intermediate point index
			
			this._index = index;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor().initialize(this));
			return this;
		},
		getIndex: function(){
			// Summary:
			//		returns the index of the adorned link intermediate point
			return this._index;
		},
		changeBindings:function(intermediatePoints){
			// Summary:
			//		modify the handle internal bindings
			var p1 = intermediatePoints[this._index];
			var p2 = intermediatePoints[this._index+1];
			var point = {x: ((p2.x-p1.x)/2+p1.x), y:((p2.y-p1.y)/2+p1.y)};
			this.startDTLBatch();
			this.setAddPointPosX(point.x);
			this.setAddPointPosY(point.y);
			this.endDTLBatch();
		}
	}));

	ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle.templateId = "LinkIntermediatePointsAddHandle";
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle, "addPointPosX", -99999);
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle, "addPointPosY", -99999);

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor');







(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;

dojo.declare("ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor", [ibm_ilog.diagram.interactors.DragInteractor], {
	// Summary:
	//		this class is the interactor associated to the LinkIntermediatePointHandle. 
	// 		It manages the functionality to edit the position of its point, and to delete it.

	//	_handle: /*LinkIntermediatePointsHandle*/
	_handle:null,
	_link:null,
	_targetPosition: null,
	_newPoint: null,
	_oldPoint: null,
	_minimumAngle: null,
	
	_declareStates: function() {
	// Summary:
	//		Add the deleteIntermediatePoint to the original states
		this.inherited(arguments);	
		this._declareState("idle",["start","deleteIntermediatePoint"]);
	},
	
	getDefaultConnections:function(){
		//
		//	summary:
		//		returns the default event mapping
		//
    		var map = this.inherited(arguments);
    		map.deleteIntermediatePoint = {src:this._getInitialEventSource(),srcEvt:"onmousedown",connectTo:"_deleteIntermediatePoint",filter:this._buildInputFilter({shift:true,button:0}), gfxConnect:true};
    		return map;
    },
	
	initialize: function( /* LinkIntermediatePointsHandle */ handle ) {
    	// Summary:
		//		sets the LinkIntermediatePointsHandle
    	this._handle = handle;
		this._viewport = handle.getViewport();
		this._initialize();
		this._minimumAngle = 7;
		return this;
	},
	
	_getInitialEventSource: function() {
		return this._handle;
	},
	
	_deleteIntermediatePoint: function(e) {
		// Summary:
		//		deletes the clicked intermediate point
		var A = this._handle.getAdorner();
		var D = A.getDiagram();
		var link = A.getAdorned();
		var intermediatePoints = link.getIntermediatePoints();
		var n = this._handle.getIndex();
		var point = intermediatePoints[n];
		link.setIntermediatePoints(intermediatePoints.slice(0,n).concat(intermediatePoints.slice(n+1)));
		A.rebindAdorned();
		D.getUndoManager().addAction(this._createRemoveUndoAction(D,link,point,n));
	},
	
    _dragPreStart: function(e) {
		this._handle.interactionBegun(this);
		this._newPoint = null;
		this._newPoint = null;
		this.inherited(arguments);
	},
	
	_dragMove: function(e) {
    	this.inherited(arguments);
		
    	var A = this._handle.getAdorner();
		var V = A.getViewport();
		var D = V.getDiagram();
		var link = A.getAdorned();
		if(link){
			var point = V.eventContentLocation(e);
			var t = link.getShapeToContainerTransform(V._diagram.getGraph().getParent()).inverse();
			var pointT = t.transformPoint(point);
			var intermediatePoints = link.getIntermediatePoints();
			var oldPoint = intermediatePoints[this._handle.getIndex()];
			if(!this._oldPoint){
				this._oldPoint = dojo.clone(oldPoint);
			}
			oldPoint.x = pointT.x;
			oldPoint.y = pointT.y;
			this._newPoint = dojo.clone(pointT);
			link.setIntermediatePoints(intermediatePoints);
		}
	},

	_dragEnd: function(e) {
		
		this.inherited(arguments);
		if(this._newPoint){
			var A = this._handle.getAdorner();
			var D = A.getDiagram();
			var link = A.getAdorned();
			var index = this._handle.getIndex();
			if(this._reachMinimunAngle(link,index)){
				D.getUndoManager().addAction(this._createModifyUndoAction(D,link,this._oldPoint,this._newPoint,index));
			}else{
				this._restoreOldPoint(link,index);
				this._deleteIntermediatePoint(e);
			}
		}
		this._handle.interactionEnded(this);

	},
	_reachMinimunAngle: function(link,index){
		var p1 = link._pathPoints[index];
		var p = link._pathPoints[index+1];
		var p2 = link._pathPoints[index+2];
		var v1 = g.subPoint(p1,p);
		var v2 = g.subPoint(p,p2);
		var angle = ibm_ilog.diagram.util.ClippingUtil.vectorsAngle(v1,v2);
		angle = angle*360/(Math.PI*2);
		return angle>this._minimumAngle;
	},
	_restoreOldPoint: function(link,index){
		var intermediatePoints = link.getIntermediatePoints();
		var point = intermediatePoints[index];
		point.x = this._oldPoint.x;
		point.y = this._oldPoint.y;
	},
	_createRemoveUndoAction: function(diagram,link,point,index){
		var action = new ibm_ilog.diagram.editor.undo.ChangeLinkIntermediatePointsAction(diagram, link);
		action.setRemovePointOperation(index,point);
		return action;
	},
	_createModifyUndoAction: function(diagram,link,oldPoint,newPoint,index){
		var action = new ibm_ilog.diagram.editor.undo.ChangeLinkIntermediatePointsAction(diagram, link);
		action.setModifyPointOperation(index,newPoint,oldPoint);
		return action;
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle');





(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		// Summary:
		//		this class is the handle that manage the link intermediate points. 
		//		Contains the instance of LinkIntermediatePointsHandleInteractor that enables to remove and edit these points.
		
		//
		//	_location: handle position
		//
		_index: null,
		setUp: function(index) {
		// Summary:
		//		sets the handle Intermediate point index
			
			this._index = index;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor().initialize(this));
			return this;
		},
		getIndex: function(){
			// Summary:
			//		returns the index of the adorned link intermediate point
			return this._index;
		},
		changeBindings:function(intermediatePoints){
			// Summary:
			//		modify the handle internal bindings
			var point = intermediatePoints[this._index];
			this.startDTLBatch();
			this.setIntPointPosX(point.x);
			this.setIntPointPosY(point.y);
			this.endDTLBatch();
		}
	}));

	ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle.templateId = "LinkIntermediatePointsHandle";
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle, "intPointPosX", -99999);
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle, "intPointPosY", -99999);

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.AddIntermediatePointInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.AddIntermediatePointInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.AddIntermediatePointInteractor');






(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;

dojo.declare("ibm_ilog.diagram.editor.interactors.AddIntermediatePointInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	// summary:
	//		this interactor is created in the LinkIntermediatePointAdorner and have the functionality 
	//		to add intermediate points to the adorned link
	
	
	//	_handle: /*LinkIntermediatePointsHandle*/
	_adorner: null,
	_viewport: null,
	
	_declareStates: function () {
		this._declareState("idle", ["add"]);
		//this._declareState("active", ["end"]);
	},

	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			add: {
				src: this._getInitialEventSource(),
				srcEvt: "onmousedown",
				connectTo: "_addIntermediatePoint",
				filter: this._buildInputFilter({shift:true,button:0}),
				gfxConnect:true
			}
		};
	},
	
	initialize: function( /* LinkIntermediatePointsAdorner */ adorner ) {
		// summary:
		//		sets the LinkIntermediatePointsAdorner and initialize its superclass
		this._adorner = adorner;
		this._viewport = adorner.getViewport();
		this._initialize();
		return this;
	},
	
	_getInitialEventSource: function() {
		return this._adorner._path;
	},
	
	_addIntermediatePoint: function(e) {
		// summary:
		//		Add the intermediate point to the adorned link
		var link = this._adorner.getAdorned();
		var V = this._adorner.getViewport();
		var D = V.getDiagram();
		if(link){
			var intermediatePoints = link.getIntermediatePoints();
			var point = V.eventContentLocation(e);
			var t = link.getShapeToContainerTransform(D.getGraph().getParent()).inverse();
			var pointT = t.transformPoint(point);
			var index = this._getCloserSegmentIndex(link,intermediatePoints,pointT);
			ibm_ilog.diagram.editor.EditingUtils.addItermediatePoint(D,link,pointT,index);
			this._adorner.rebindAdorned();
		}
		dojo.stopEvent(e);
	},
	_getCloserSegmentIndex: function(link,intermediatePoints,point){
		// summary:
		//		return the index of the closer link segment to the point
    	var distance = Number.MAX_VALUE;
    	var index = -1;
    	var startPoint = link._pathPoints[0];
    	var endPoint = link._pathPoints[link._pathPoints.length - 1];
    	intermediatePoints = [startPoint].concat(intermediatePoints).concat([endPoint]);
    	for(var i=1;i<intermediatePoints.length;i++){
    		var a = intermediatePoints[i-1];
    		var b = intermediatePoints[i];
    		var d = g.getPointToSegmentDistance(a,b,point);
    		if(distance>d){
    			distance = d;
    			index = i-1;
    		}
    	}
    	return index;
    }
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAdorner');







(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
    
	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAdorner',[ibm_ilog.diagram.adorners.LinkAdorner],{
		// Summary:
		//		this class is the adorner that contains the LinkIntermediatePointsHandler. 
		//		These handles enables the user to delete and edit link intermediate points.
		//		Also, it creates an instance of the AddIntermediatePointInteractor that enables 
		//		to create new intermediate point at the adorned link
		_intermediatePoints: null,
		_addPointInteractor: null,
		_useHandleInteractorToAdd: null,
		initialize: function(){
		// Summary:
		//		initialize the Adorner and create the instance of the AddIntermediatePointInteractor.
			this.inherited(arguments);
			this.enableHandleInteractorToAdd(true);
			this._addPointInteractor = new ibm_ilog.diagram.editor.interactors.AddIntermediatePointInteractor();
		},
		enableHandleInteractorToAdd: function(enabled){
			// Summary:
			//		This method set the use of individual Interactors to add intermediate points (click over handles), or use the general Interactor (Shift+click over link).
			this._useHandleInteractorToAdd = enabled;
		},
		setAdorned: function (element) {
			//	summary:
			//		apply the adorner to the given element. This method creates all the necessary LinkIntermediatePointsHandler and deletes any previously created instances.
			//
			
			if(element){
				var shapeType = element.getShapeType();
				if (shapeType != ibm_ilog.diagram.LinkShapeType.Free &&
				        this._shapeType != ibm_ilog.diagram.LinkShapeType.OrthogonalEditable){
					return; // do not set the adorner
				}
				
				this._intermediatePoints = [];
				this.createAllHandles(element);
				if(!this._useHandleInteractorToAdd){
					this._addPointInteractor.initialize(this);
					this._addPointInteractor.reactivate();
				}
			}else{
				this._clearHandles();
				if(!this._useHandleInteractorToAdd){
					this._addPointInteractor.deactivate();
				}
			}
			this.inherited(arguments);
			this._path.moveToBack();
			this.moveToFront();
		},
		rebindAdorned: function(){
			//	summary: 
			//		rebind the adornet to the same adorned link.
			//		This method should be called when the number of intermediate links varies.

			var link = this.getAdorned();
			this.setAdorned(null);
			this.setAdorned(link);
		},
    	createAllHandles: function(element){
			//	summary: 
			//		This method creates all the necessary LinkIntermediatePointsHandler
			var size = element.getIntermediatePoints().length;
			if(this._useHandleInteractorToAdd){
				this._createDynamicHandle(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle,"addPointGroup").setUp(0);
			}
			for(var index = 0;index<size;index++){
    			this._createDynamicHandle(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle,"currentPointGroup").setUp(index);
    			if(this._useHandleInteractorToAdd){
    				this._createDynamicHandle(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle,"addPointGroup").setUp(index+1);
    			}
    		}
    	},
    	_createDynamicHandle: function (clazz,attachPointName) {
			if (this[attachPointName]) {
				var template = this._templatePool.item(this[attachPointName].template || clazz.templateId);
				var handle = this[attachPointName].createObject(clazz);
				handle.initialize(this, template);
				this._handles.add(handle);
				return handle;
			} else {
				return null;
			}
		},
		_clearHandles: function(){
			//	summary: 
			//		This method deletes any previously created LinkIntermediatePointsHandler instances.
			this._handles.forEach(function(handle){
				handle.getParent().remove(handle);
			});
			this._handles.clear();
		},
    	_updateLayout: function () {

    		// [AV] updates from "updateShapeBoundProperty" dont work with composite properties
    		// e.g. bounds.width   
    		//      bounds.height
    		//
    		// Correcting this may also be faster, only one rebinding process is needed
    		
    		this.inherited(arguments);
    		if (this.getAdorned()) {
        		var transformationFunction = dojo.hitch(this, function (point, list) {
					var v = this._viewport,
						z = v.getZoom(),
						vr = v.getViewRect();
					var t = this._adorned.getShapeToContainerTransform(v._diagram.getGraph().getParent());
					point = t.transformPoint(point);
					point = g.moveRect(point, g.negPoint(vr));
					point.x = point.x * z;
					point.y = point.y * z;
					return point;
				});
				var points = dojo.map(this.getAdorned().getIntermediatePoints(),transformationFunction);
				this._intermediatePoints = points;
				this._notifyHandles();
    		}
    	},
    	_notifyHandles: function(){
    		// summary:
    		//		notify all the handles of the point modification
    		this._handles.forEach(function(handle){
    			if(handle._isAddHandle){
    				handle.changeBindings([{x:this.getLinkStartX(),y:this.getLinkStartY()}].concat(this._intermediatePoints).concat({x:this.getLinkEndX(),y:this.getLinkEndY()}));
    			}else{
    				handle.changeBindings(this._intermediatePoints);
    			}
    		},this);
    	}

    }));

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ResizeHandleInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ResizeHandleInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ResizeHandleInteractor');






(function () {
	var g = ibm_ilog.diagram.util.Geometry;

dojo.declare("ibm_ilog.diagram.editor.interactors.ResizeHandleInteractor", [ibm_ilog.diagram.interactors.DragInteractor], {
	//
	//	summary:
	//		Handles the interaction of a resize handle while resizing the related adorned.
	//	
	
	//
	//	_handle: /*ibm_ilog.diagram.editor.adorners.ResizeHandle*/
	//		The ResizeHandle associated with the interactor.
	//
	_handle: null,

	initialize: function ( /* ibm_ilog.diagram.editor.adorners.ResizeHandle */ handle ) {
		//
		//	summary:
		//		Initializes the interactor to work with the given handle
		//
		this._handle = handle;
		this._viewport = handle.getViewport();
		this._initialize();
		return this;
	},

	_getInitialEventSource: function () {
		return this._handle;
	},

	_refreshTransform: function () {
		var a = this._handle._adorner;
		if(a._adorned) {
			this._transform = a._adorned.getTransformToContainer(a._viewport.getSurface()).inverse();
		}
	},

	activate: function () {
		this.inherited(arguments);
	},

	_dragPreStart: function () {
		this._refreshTransform();
		this._connect("updateTransforms", this._handle._adorner._viewport, "onViewRectChanged", this, "_refreshTransform");
		this._handle.interactionBegun(this);
		this.inherited(arguments);
	},

	_dragEnd: function () {
		this._disconnect("updateTransforms");
		var dragged = this.hasDragged, action, D;
		this.inherited(arguments);
		this._handle.interactionEnded(this);
		if(dragged){
			action = this._handle.createUndoAction();
			D = this._viewport.getDiagram();
			D.getUndoManager().addAction(action);
		}
	},

	_dragMove: function () {
		this.inherited(arguments);
		this._handle.resize(this._totalDelta);
	}

});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ResizeHandle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ResizeHandle'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ResizeHandle');








(function() {
	var g = ibm_ilog.diagram.util.Geometry,	Rect = g.Rect,	EmptyRect = g.EmptyRect,	Size = g.Size,	PointZero = g.PointZero,	Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;

ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ResizeHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
	//
	//	summary:
	//		A handle that is associated with a corner of the adorner 
	//		bouding box and allows to resize the adorned by grabbing that 
	//		corner.
	//
	
	//
	//	_location: Point
	//		The corner of the adorned BB associated with the handle. Each 
	//		coord may have a value of 0 or 1 indicating the left or right 
	//		and top or down respectively. 
	//
	location: null,

	//
	//	_startBB:
	//		The original BB of the adorned
	//
	_startBB: null,
	_endBB: null,
	
	setup: function(location) {
		this.location = location;
		this.addInteractor(new ibm_ilog.diagram.editor.interactors.ResizeHandleInteractor().initialize(this));
		return this;
	},

	interactionBegun: function() {
		this.inherited(arguments);
		this._startBB = this._adorner._adorned.getBounds();
		this._endBB = this._startBB;
	},

	resize: function(delta) {

		var ge = this._adorner._adorned;
		var bb = g.cloneRect(this._startBB);
		var min = ge.minimumSize;
		
		switch(this.location.x) {
		case 0:
			delta.x = bb.width-Math.max(bb.width-delta.x,min.width);
			bb.x = bb.x + delta.x;
			bb.width = bb.width - delta.x;
			break;
		case 1:
			bb.width = Math.max(min.width,bb.width + delta.x);
			break;
		}			
		
		switch(this.location.y) {
		case 0:
			delta.y = bb.height-Math.max(bb.height-delta.y,min.height);
			bb.y = bb.y + delta.y;
			bb.height = bb.height - delta.y;
			break;
		case 1:
			bb.height = Math.max(min.height,bb.height + delta.y);
			break;
		}			
		
		ge.setBounds(bb);
		this._endBB = bb;
	},
	
	createUndoAction: function(){
		
		var action = new ibm_ilog.diagram.editor.undo.SimpleAction(ibm_ilog.diagram.editor.undo.UndoActionList.Resize);
		
		action.setOldValue(this._startBB);
		action.setNewValue(this._endBB);
		action.setMethodOrProperty('setBounds');
		action.setModifiedElementId(this._adorner._adorned.getId());
		return action;
	}

}));

ibm_ilog.diagram.editor.adorners.ResizeHandle.templateId = "ResizeHandle";

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.ResizeAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.ResizeAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.ResizeAdorner');





(function() {

	var g = ibm_ilog.diagram.util.Geometry,	Rect = g.Rect,	EmptyRect = g.EmptyRect,	Size = g.Size,	PointZero = g.PointZero,	Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;

ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ResizeAdorner', [ibm_ilog.diagram.adorners.AdornerWithHandles], {
	//
	//	summary:
	//		An adorner with handles to resize the adorned.
	//	description:
	//		This Adorner creates 4 ResizeHandles, one at each corner of the 
	//		adorned bouding box.
	//		Each ResizeHandle allows to grab that corner of the bounding box 
	//		and resize the adornee by moving that corner.
	//
	initialize: function () {
		this.inherited(arguments);

		this._createResizeHandle("hndTL", Point(0, 0));
		this._createResizeHandle("hndTR", Point(1, 0));
		this._createResizeHandle("hndBL", Point(0, 1));
		this._createResizeHandle("hndBR", Point(1, 1));
	},

	_createResizeHandle: function (attachPoint, p) {
		var h = this._createHandle(ibm_ilog.diagram.editor.adorners.ResizeHandle, attachPoint);
		if (h) {
			h.setup(p);
		}
	}

}));

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.adorners.TextEditAdorner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.adorners.TextEditAdorner'] = true;
dojo.provide('ibm_ilog.diagram.editor.adorners.TextEditAdorner');








dojo.requireIf(dojo.config.isBidiInDojoDiagrammer, 'ibm_ilog.diagram.util.BidiUtil');

(function() {

	var __set = ibm_ilog.diagram._base.dojoext.SetAttrName;
	var __get = ibm_ilog.diagram._base.dojoext.GetAttrName;

var cls = ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.TextEditAdorner', [ibm_ilog.diagram.editor.adorners.ComponentAdorner], {

	//	summary:
	//		An adorner for editing string-valued properties of Graph elements. 
	//	description:
	//		TextEditAdorner is an adorner that displays a TextBox for editing a 
	//		property of a Graph element. The user must provide an attachPoint name for 
	//		the property which is used to calculate the position of the TextBox, and 
	//		also a getter and setter of the property at the Graph element.   
	//	usage:
	//		The following code starts editing the "label" attribute of "node", using 
	//		getLabel/setLabel as accessorsm and "textShape" as value representation for
	//		reference when positioning the TextBox
	//
	//		textEditAdorner.setAccessors(
	//			function(adorned){
	//				return adorned.getLabel();
	//			},
	//			function(adorned,value){
	//				adorned.setLabel(value);
	//			});
	//		textEditAdorner.setComponent("textShape");
	//		textEditAdorner.setAdorned(node);
	//
	
	//
	// _lastAdorned: GraphElement
	//
	_lastAdorned: null,

	//
	//	_textbox: dijit.form.TextBox
	//
	_textbox: null,
		
	//
	//	_gettter: accessor to get the value of the property from the graph element
	//
	_getter: null,
	
	//
	//	_settter: accessor to set the value of the property to the graph element
	//
	_setter: null,

	setComponentAttachPoint: function(a) {
		//
		//	summary:
		//		Sets the component original attachpoint		 
		//
		this._componentAttachPoint = a;
	},

	getComponentAttachPoint: function() {
		//
		//	summary:
		//		Returns the attachPoint name of the visual shape associated with the property. 
		//
		return this._componentAttachPoint;
	},

	initialize: function () {
		this.inherited(arguments);
		
		// get textbox from template attachPoint  

		// this.textbox is the GfxWidget declared at the template
		this._textbox = this.textbox._widget;
	},

	setAccessors: function(getter,setter) {
		//
		//	summary:
		//		Configure the receiver with the setter and getter functions for the property on the graph element. 
		//
		this._getter = getter;
		this._setter = setter;
	},

	_onBlur: function() {
		//
		//	summary:
		//		unlink the adorner when the textbox looses focus
		//
		this.setAdorned(null);
	},
	
	_getTextBoxValue: function(){
		var value = this._textbox[__get]("value");
		// prevent DTL from escaping HTML, even if the binding was not marked with |safe.
		if(dojox.dtl)
			value = dojox.dtl.mark_safe(value);
		return value;
	},
	
	_setTextBoxValue: function(value){
		this._textbox[__set]("value", value);
	},
	
	_onKey: function(e) {
		//
		//	summary:
		//		Handle special keys:
		//			Enter: accepts the value and sets it to the currently adorned graph element.
		//			Esc: cancels the operation and hides the adorner.
		//
		if(e.keyCode==dojo.keys.ENTER && !e.shiftKey) { // ENTER
			var value = this._getTextBoxValue();
			if(value!=this._getter(this._lastAdorned)) {
				var action = this._createUndoAction(this._lastAdorned,value);
				this._setter(this._lastAdorned,value);
				this._diagram.getUndoManager().addAction(action);
			}
			dojo.stopEvent(e);
			this.setAdorned(null);
			dijit.focus(this._diagram.domNode);
		} else if(e.keyCode==dojo.keys.ESCAPE) { // ESC
			dojo.stopEvent(e);
			this.setAdorned(null);
			dijit.focus(this._diagram.domNode);
		}
		else if (dojo.config.isBidiInDojoDiagrammer) { //Bidi support
		    var textdir = this._diagram.textDir;
		    if ((textdir === undefined) || (textdir === ""))
		        return;
		    if (textdir == "auto") {
		        var value = this._getTextBoxValue();
	            textdir = ibm_ilog.diagram.util.BidiUtil.checkDir(value);
		        if (textdir == "rtl")
		          this._textbox[__set]("dir", "rtl");				         
		        else 
		          this._textbox[__set]("dir", "ltr");
		   }
		}		
	},
	
	_onPaste: function() {
		//
		//	summary:
		//      resolve "auto" text direction for pasted text
		//		unlink the adorner when the textbox looses focus
		//

	    var textdir = this._diagram.textDir;
	    if ((textdir === undefined) || (textdir === ""))
	        return;
	    if (textdir == "auto") {
	        var value = this._getTextBoxValue();
	        textdir = ibm_ilog.diagram.util.BidiUtil.checkDir(value);
	        if (textdir == "rtl")
	           this._textbox[__set]("dir", "rtl");		         
	        else 
	           this._textbox[__set]("dir", "ltr");
	   }
	},
	
	_createUndoAction: function(adorned,value){
		//
		//	summary:
		//		Create an Undo object for the operation of changing the 
		//		associated property to "value" on "adorned"
		//
		var action = new ibm_ilog.diagram.editor.undo.SimpleAction('EditText');
		action.setOldValue(adorned.getLabel());
		action.setNewValue(value);
		action.setModifiedElementId(adorned.getId());
		action.setter = this._setter;
		action.changeFunction = dojo.hitch(action,function(value){	
			var modifiedObject = this.getModifiedElement();
			this.setter(modifiedObject,value);
		});
		return action;
	},
	
	clear: function() {
		//
		//	summary:
		//		Clear the value of the TextBox
		//
		this._setTextBoxValue("");
	},
	
	reset: function() {
		//
		//	summary:
		//		Rest the value of the TextBox to the original value found at the adorned object
		//
		var value = this._getter(this._lastAdorned);
		
		//set text direction to TextBox
        if (dojo.config.isBidiInDojoDiagrammer) {
		    var textdir = this._diagram.textDir;
		    if (textdir == "auto")
		        textdir = ibm_ilog.diagram.util.BidiUtil.checkDir(value);
            if (textdir == "rtl")
		        this._textbox[__set]("dir", "rtl");
            else if (textdir == "ltr")
		        this._textbox[__set]("dir", "ltr");
		} 	
				
		this._setTextBoxValue(value);
	},
	
	setOptions: function(options) {
		// instantiation options
		// TODO check why this is not working.
		if(options.style) {
			dojo.style(this._textbox.focusNode,options.style);
		}
	},

	setAdorned: function(e) {
		//
		//	summary:
		//		Change the adorned object. This causes the TextBox to appear at the corresponding 
		//		location (based on the location of the graph element and the location of the 
		//		property shown inside the element). 
		//		If null, the TextBox is hidden and unbinded.
		//
		this._disconnect("blur");
		this._disconnect("key");
		if (dojo.config.isBidiInDojoDiagrammer)
		    this._disconnect("paste");				
		this.clear();
		this.inherited(arguments);
		if(e) {
			this._lastAdorned = e;
			this.reset();
			this._textbox.focus();
			dijit.selectInputText(this._textbox.focusNode);

			// If the textbox looses focus, cancel.
			this._connect("blur",this._textbox,"onBlur",this,"_onBlur");

			// Handle Enter and Esc keys
			this._connect("key",this._textbox,"onKeyPress",this,"_onKey");
			
			//for contextual text direction, text direction of editor depends on pasted text 
			if (dojo.config.isBidiInDojoDiagrammer)
			    this._connect("paste",this._textbox,"_onInput",this,"_onPaste");				
		} else {
			this._textbox.domNode.blur();
		}
	},
		
	_updateLayout: function() {
		//
		//	summary:
		//		Publish new geometric values (causes template bindings to be applied if changed).
		//
		
		this.startDTLBatch();

		this.inherited(arguments);
		
		if(this._componentAttachPoint && this._componentAttachPoint.getFont) {
			var z = dojox.gfx.normalizedLength(this._componentAttachPoint.getFont().size);
			this.setRefFontPxSize(z*this._component._getRealMatrix().yy);
		}

		this.endDTLBatch();
	}
	
}));

ibm_ilog.diagram.templating.declareBindableProperty(cls, "refFontPxSize", 10);

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.undo.PasteNodeAction']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.undo.PasteNodeAction'] = true;
dojo.provide('ibm_ilog.diagram.editor.undo.PasteNodeAction');




dojo.declare("ibm_ilog.diagram.editor.undo.PasteNodeAction", [ibm_ilog.diagram.editor.undo.UserCustomizedAction], {
	elementId: null,
	parentId: null,
	template: null,
	transformation: null,
	label: null,
	isSubgraph: null,
	collapsed:false,
	constructor:function(){
		this.setLabel(ibm_ilog.diagram.editor.undo.UndoActionList.Paste);
		this.initialize(dojo.hitch(this,this._undoFunction),dojo.hitch(this,this._redoFunction));
	},
	_undoFunction: function(){
		var ge = this.getUndoManager().getRegisteredGraphElement(this.elementId);
		ge.getParent().remove(ge);
		ge.dispose();
	},
	_redoFunction: function(){
		var container = this.getUndoManager().getRegisteredParent(this.parentId);
		var ge;
		if(this.isSubgraph){
			ge = this.getUndoManager().getDiagram().createSubgraph(this.template,null,container);
		    ge.setCollapsed(this.collapsed);
		}else{
			ge = this.getUndoManager().getDiagram().createNode(this.template,null,container);
		}
	    ge.setTransform(this.transformation);
	    ge.setLabel(this.label);
	    this.getUndoManager().registerGraphElementReplacement(this.elementId,ge.getId());
	}
});

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.DiagramSerializer']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.DiagramSerializer'] = true;
dojo.provide('ibm_ilog.diagram.editor.DiagramSerializer');








(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var gu = ibm_ilog.diagram.util.GraphUtil;
	var m = dojox.gfx.matrix;
	var d = dojo;


var mixinAtts = function mixinAtts(target,src,these) {
//	var count = 0;
	for(var i = 0; i < these.length; i++ ) {
		if(src[these[i]] !== undefined) {

// debugging:
//			if(target[these[i]]) {
//				console.log("overriding ",these[i], ",",target[these[i]], ",",src[these[i]]);
//			} else {
//				console.log("adding     ",these[i], ",",target[these[i]], ",",src[these[i]]);
//			}

			target[these[i]] = src[these[i]];
			
//			count ++;
		}
	}
//	return count;
};

var serializeAtt = function serializeAtt(obj,t,name) {
	var v;
	if(obj["get"+name]){
		v = obj["get"+name]();
		if(v){ t[name] = v; }
	}
};

var deserializeAtt = function deserializeAtt(obj,t,name) {
	if(name in t) {
		obj["set"+name](t[name]);
	}
};	

serializeShapeStates = function serializeShapes ( shape ){
	
	var t = {}, v;
	
	if(shape._isIBMDiagramGraph) {
		return; // we skip the Graph object at subgraphs 
	}
	
	if(shape instanceof dojox.gfx.Group){
		t.children = d.map(shape.children, serializeShapeStates);
	}

	if(shape.getLayout) {
		v = shape.getLayout();
		if(v) {
			t.layout = v.getConfig();
		}
	}
	
	serializeAtt(shape,t,"ExplicitSize");

	mixinAtts(t,shape,["selectedStyle"]);
	mixinAtts(t,shape,["minimumSize","maximumSize", "valign", "halign", "col", "row","margins"]);

	return t;	// shape
};

function deserializeShapeStates(shape,t) {

	if(shape._isIBMDiagramGraph) {
		return;
	}

	if(shape instanceof dojox.gfx.Group){
		
		if(!t.children) {
			//console.log("not an array @ t:",shape,t);
		} else {
			if(shape.children.length != t.children.length) {
				//console.log("not of same length:",shape.children.length,t.children.length);
			} else {
				mixinAtts(shape,t,["selectedStyle"]);
				
				if(t.layout) {
					shape.setLayout(t.layout);
				}

				deserializeAtt(shape,t,"ExplicitSize");
				
				mixinAtts(shape,t,["minimumSize","maximumSize", "valign", "halign", "col", "row","margins"]);
			}
		}
		
		for(var i = 0; i< shape.children.length; i++) {
			deserializeShapeStates(shape.children[i],t.children[i]);
		}
	}
};
	
dojo.declare("ibm_ilog.diagram.editor.DiagramSerializer",null,{
	_serializer: null,
	_notifiyingObject: null,
	_diagram: null,
	_transformFunction: null,
	
	constructor: function(diagram,transformFunction,notifiyingObject){
		this._notifiyingObject = notifiyingObject;
		this._diagram = diagram;
		this._transformFunction = transformFunction;
		this._initializeSerializer();
	}, 
	serialize: function(toSerialize){
		return this._serializer.serialize(toSerialize);
	},
	deserialize: function(serialized,container){
		return this._serializer.deserialize(serialized,container);
	},
	_initializeSerializer: function(){
		var thiz = this;
		this._serializer = new ibm_ilog.diagram.util.Serializer({
			getId: function(ge) {
				return ge.getId();
			},
			serializeNodeData: function(ge){
				var serializedData = {
					id:ge.getId(),
					label:ge.getLabel(),
					transform:m.clone(ge.getTransform()),
					uibb:ge.getBounds(this.getDiagram().getViewport().getSurface()),
					template:ge._template,
					shapesStates:serializeShapeStates(ge)
				};
				this.getNotifiyingObject().onSerialize(ge,serializedData);
				return serializedData;
			},
			deserializeNodeData: function(s,newByOldId,container){
			    var node = this.getDiagram().createNode(s.template,null,container.graph);
			    var t = this.getTransformFunction()(s.transform,container.graph,s);
			    node.setTransform(t);
			    node.setLabel(s.label);

			    deserializeShapeStates(node,s.shapesStates);
			    if (dojo.config.useGfxLayout) {
					node.invalidate();
				}
			    
			    var undoAction = this._createNodeUndoAction(s,node.getId(),t,container,false);
			    this.getNotifiyingObject().onDeserialize(s,node,container,undoAction);
			    container.undo.addAction(undoAction);
			    return {created:node};
			},
			serializeSubgraphData: function(ge){
				var serializedData = {
					id:ge.getId(),
					label:ge.getLabel(),
					collapsed:ge.isCollapsed(),
					clss:ge.constructor,
					transform:m.clone(ge.getTransform()),
					uibb:ge.getBounds(this.getDiagram().getViewport().getSurface()),
					template:ge._template,
					collapsedShapeStates:serializeShapeStates(ge._collapsedGroup),
					expandedShapeStates:serializeShapeStates(ge._expandedGroup)
				};
				this.getNotifiyingObject().onSerialize(ge,serializedData);
				return serializedData;
			},
			deserializeSubgraphData: function(s,newByOldId,container){
			    var sg = this.getDiagram().createSubgraph(s.template,null,container.graph,s.clss);
			    var t = this.getTransformFunction()(s.transform,container.graph,s);
			    sg.setLabel(s.label);

			    // TODO this is a hack to prevent current imposibility of creating subgraphs while collapsed
			    // assign position after deserializing
			    setTimeout(function(){
				    if(s.collapsed!=sg.isCollapsed()) {
				    	sg._setCollapsed(s.collapsed,false); // TODO allow animation control publicly at Subgraph
				    }
				    sg.setTransform(t);
			    },1);

			    // TODO hack: hide if we can
			    
			    // TODO fixed by gino commented and added sg.setTransform(t);
			    
			    /*if(!container.graph._owningSubgraph) {
			    	sg.setTransform(m.translate(ibm_ilog.diagram._invisibleLocation,ibm_ilog.diagram._invisibleLocation));
			    } else {
				    sg.setTransform(t);
			    }*/
			    //sg.setTransform(t);

				deserializeShapeStates(sg._collapsedGroup,s.collapsedShapeStates);
				deserializeShapeStates(sg._expandedGroup,s.expandedShapeStates);
				if (dojo.config.useGfxLayout) {
					sg.invalidate();
				}
			    var undoGroup = new ibm_ilog.diagram.editor.undo.MultipleAction();
			    var undoAction = this._createNodeUndoAction(s,sg.getId(),t,container,true);
			    this.getNotifiyingObject().onDeserialize(s,sg,container,undoAction);
			    undoGroup.addAction(undoAction);
			    container.undo.addAction(undoGroup);
			    return {created:sg,graph:sg.getGraph(),undo:undoGroup};
			},
			serializeLinkData: function(ge){
				var serializedData = {
					startId:ge.getStartNode().getId(),
					endId:ge.getEndNode().getId(),
					shapeType:ge.getShapeType(),
					transform:m.clone(ge.getTransform()),
					intermediatePoints:ge.getIntermediatePoints()
				};
				this.getNotifiyingObject().onSerialize(ge,serializedData);
				return serializedData;
			},
			deserializeLinkData: function(s,newByOldId,container){
				if(newByOldId.contains(s.startId) && newByOldId.contains(s.endId)) {
					var link = container.graph.createLink();
					var start = newByOldId.item(s.startId).created;
					var end = newByOldId.item(s.endId).created;
					link.setStartNode(start);
					link.setEndNode(end);
					link.setShapeType(s.shapeType);
					var points = dojo.clone(s.intermediatePoints);
					if (points) {
					    var t = this.getTransformFunction()(s.transform,container.graph,null);
						for (var i = 0; i < points.length; i++) {
							points[i] = t.transformPoint(points[i]);
						}
					}
					link.setIntermediatePoints(points);
					this.getDiagram()._onLinkCreated(link,start,end,this.getDiagram());
					var undoAction = this._createLinkUndoAction(link,container);
					this.getNotifiyingObject().onDeserialize(s,link,container,undoAction);
					container.undo.addAction(undoAction);
					return {created:link};
				}
			},
			_createNodeUndoAction: function(s,newId,t,container,isSubgraph){
			    var action = new ibm_ilog.diagram.editor.undo.PasteNodeAction();
			    action.elementId = newId;
			    action.parentId = this.getDiagram().getUndoManager().getParentId(container.graph);
			    action.template = s.template;
			    action.transformation = m.clone(t);
			    action.label = s.label;
			    action.isSubgraph = isSubgraph;
			    action.collapsed = s.collapsed;
			    return action;
			},
			_createLinkUndoAction: function(link,container){
				var action = new ibm_ilog.diagram.editor.undo.ConnectAction(this.getDiagram(),link,container.graph);
				return action;
			},
			getDiagram: dojo.hitch(thiz,function(){
				return this._diagram;
			}),
			getNotifiyingObject: dojo.hitch(thiz,function(){
				if(this._notifiyingObject){
					return this._notifiyingObject;
				}else{
					//Dummy notifyingObject
					return {onSerialize:function(){},onDeserialize:function(){}};
				}
			}),
			getTransformFunction: dojo.hitch(thiz,function(){
				
				if(this._transformFunction){
					return this._transformFunction;
				}else{
					return function(t){return t;};
				}
			})
		});
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.Clipboard']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.Clipboard'] = true;
dojo.provide('ibm_ilog.diagram.editor.Clipboard');










(function () {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var gu = ibm_ilog.diagram.util.GraphUtil;	
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;
	var eu = ibm_ilog.diagram.editor.EditingUtils;

dojo.declare("ibm_ilog.diagram.editor.Clipboard", null , {
	
	_diagram: null,
	_serializer: null, 
	_pasteContainer : null,
	_clipboard: null, 
	_pasteXY: null, 
	_pasteBB: null, 

	_nextPasteLocations: null,
	
	//
	//	_nextPasteLocationDelta: Point
	//		The delta used to compute _nextPasteLocation.
	//
	_nextPasteLocationDelta: g.Point(25,25),

	setNextPasteLocationDelta: function(value) {
		//
		//	summary:
		//		Set the delta used to compute _nextPasteLocation.
		//
		this._nextPasteLocationDelta = value;
	},	
	
	getNextPasteLocationDelta: function(value) {
		//
		//	summary:
		//		Get the delta used to compute _nextPasteLocation.
		//
		return this._nextPasteLocationDelta;
	},

	constructor: function(diagram){
		// summary:
		//		creates a new clipboard instance, initializing a new serializer.
		
		this._nextPasteLocations = new dojox.collections.Dictionary();
		
		this._diagram = diagram;
		this._initializeSerializer();
	},
	
	getDiagram: function(){
		// summary:
		//		returns the associated diagram.
		// return: ibm_ilog.diagram.editor.DiagramEditor
		return this._diagram;
	},
	
	_basicCopy: function() {
		// summary:
	    //		This method serializes the selected elements to the clipboard, and save it for further paste.
		var maximals = gu.maximals(this._diagram.getSelection().fastGet().toArray())
		if(!this._isEmpty(maximals)){
			var bb = this._getBoundsOf(maximals);
			var lca = gu.lowestCommonAncestor(maximals);
			
			this._nextPasteLocations.clear();
			
			var bbxy = {x:bb.x,y:bb.y};
			var localxy = lca._getRealMatrix().inverse().transformPoint(bbxy);
			this._nextPasteLocations.add(lca.getId(),localxy);

			this._clipboard = this._serializer.serialize(maximals);
			dojo.publish("/ibm_diagram/Clipboard/copied", [maximals]);
			return maximals;
		}
		return null;
	},
	
	copy: function() {
		// summary:
    //		This method serializes the selected elements to the clipboard, and save it for further paste.
		if(this._basicCopy()) {
			var entry = this._nextPasteLocations.getIterator().get();
			entry.value = g.addPoint(entry.value,this._nextPasteLocationDelta);
			
		}		
	},
	
	cut: function(){
		// summary:
	    //		This method serializes the selected elements to the clipboard, and save it for further paste.
		//		Also deletes the selected elements after the copy.
		if(this._basicCopy()) {
			var selected = this._diagram.getSelection().fastGet().toArray();
			var action = eu.deleteGraphElements(this._diagram,selected);
			this._diagram.getUndoManager().addAction(action);
		}
	},
	
	clear: function(){
		// summary:
	  //		This method clears the clipboard and signals the event "/ibm_diagram/Clipboard/cleared".
		//
		this._clipboard = null; 
		dojo.publish("/ibm_diagram/Clipboard/cleared",[]);
	},
	
	paste: function(pasteContainer,pasteLocation) {
		//
		//	summary:
	  //		Pastes previously copied content into the diagram.
		//	pasteContainer: ibm_ilog.diagram.Graph
		//		The Graph into which the contents of the clipboard are going to be pasted.
		//
		if(this._clipboard){
			this._pasteContainer = pasteContainer;
			if(!pasteLocation) {
				var storedLoc = this._nextPasteLocations.item(pasteContainer.getId());
				if(storedLoc) {
					pasteLocation = storedLoc;
				} else {
					pasteLocation = storedLoc = {x:0,y:0};
				}
				storedLoc = g.addPoint(storedLoc,this._nextPasteLocationDelta);
				this._nextPasteLocations.add(pasteContainer.getId(),storedLoc);
			}

			this._pasteXY = pasteLocation;
			this._pasteBB = this._calculateBB(this._clipboard); 
			var undoGroup = new ibm_ilog.diagram.editor.undo.MultipleAction(ibm_ilog.diagram.editor.undo.UndoActionList.Paste);
		
			// add a connection to select all deserialized elements.
			var elements = [];
			var connection = dojo.connect(this,'onDeserialize',
										  this,function(serialized,newElement){
			                						elements.push(newElement);
												});
		
			this._serializer.deserialize(this._clipboard,{graph:this._pasteContainer,undo:undoGroup});
			this._diagram.getUndoManager().addAction(undoGroup);
		
			//disconnect
			dojo.disconnect(connection);
		
			//selects the deserialized top elements
			var maximals = ibm_ilog.diagram.util.GraphUtil.maximals(elements);
			this._diagram.getSelection().add(maximals,true);
			dojo.publish("/ibm_diagram/Clipboard/pasted", [maximals]);
			//this._advancePasteLocation();
		}
	},
	
	getSerializer: function(){
		// summary:
		//		returns the pre-configured serializer, ready for the copy-paste action.
		// return: ibm_ilog.diagram.editor.DiagramSerializers
		return this._serializer;
	},
	
	_calculateBB: function(serialized) {
		var bb = null;
		dojo.forEach(serialized,function(e) {
			if(e.data.uibb) {
				if(bb) {
					bb = g.addRect(bb,e.data.uibb);
				} else {
					bb = e.data.uibb;
				}
			}
		});
		return bb;
	},
	
	_initializeSerializer: function(){
		var t = dojo.hitch(this,this._adjustTransform);
		this._serializer = new ibm_ilog.diagram.editor.DiagramSerializer(this._diagram,t,this);
	},
	
	_adjustTransform: function(t,c,s) {
		// if this is toplevel, reassign t offsets such that pasteXY is the new translation
		if(c==this._pasteContainer) {
			if(!s){
				// compute transform for link intermediate points
				return m.multiply(m.translate(g.subPoint(this._pasteXY, this._pasteBB)), t);
			}
			t.dx=0;	t.dy=0;
			var newp = this._pasteXY;
			newp = g.addPoint(g.subPoint(s.uibb,this._pasteBB),newp);
			return m.multiply(m.translate(newp),t);
		} else return t;
	},
	
	_isEmpty:function(array) {
		// summary:
		//		verifies if an array is empty
		for(var i in array) {
			return false; 
		}
		return true; 
	},
	
	onSerialize: function(graphElement,serializedData){
		// summary:
		//		this function is called when a graphElement is serialized in the local Serializer.
		//		The user can connect to this method to customize the serialization.
		// graphElement: ibm_ilog.diagram.GraphElement
		//		the GraphElement to be serialized
		// serializedData: JSObject
		//		the serialized version of the GraphElement
	},
	
	onDeserialize: function(serializedData,newGraphElement,container,undoAction){
		// summary:
		//		this function is called when a graphElement is deserialized in the local Serializer.
		//		The user can connect to this method to customize the deserialization.
		// serializedData: JSObject
		//		the serialized version of the GraphElement
		// newGraphElement: ibm_ilog.diagram.GraphElement
		//		the deserialized GraphElement
		// container: ibm_ilog.diagram.Graph
		//		the container object where the newGraphElement is hold
		// undoAction: ibm_ilog.diagram.editor.undo.UserCustomizedAction
		//		the undo Action to be added to the UndoManager. If the serialized object is a link, 
		//		this Action will be an instance of ibm_ilog.diagram.editor.undo.ConnectAction.
		//		In other case it will be a ibm_ilog.diagram.editor.undo.PasteNodeAction
	},
	
	_getBoundsOf: function (list) {
		//
		//	summary:
		//		return the bounds of a list of elements currently selected
		//	list: Array
		//		The list of graph elements to include
		//	tags:
		//		private
		var bb = null;
		var graph = this._diagram.getGraph();
		for(var i = 0; i<list.length; i++) {
			var b = list[i].getBounds(graph);
			if(!bb) {
				bb = b;
			} else {
				bb = g.addRect(bb,b);
			}
		}
		return bb;
	}
	
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.undo.DropAction']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.undo.DropAction'] = true;
dojo.provide('ibm_ilog.diagram.editor.undo.DropAction');






(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var eu = ibm_ilog.diagram.editor.EditingUtils;
	
	dojo.declare("ibm_ilog.diagram.editor.undo.DropAction", [ibm_ilog.diagram.editor.undo.UserCustomizedAction], {
		//	
		// summary:
		//		this action undo/redo any drop action.
		//		This action must be modified for the user if any user defined action is done on a drop action.
		//
		_droppedItem: null,
		_droppedPosition: null,
		_elementsList: null,
		_dropInteractor: null,
		
	constructor:function(){
		//	
		// summary:
		//		creates a new instance, setting the corresponding label
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.Drop;
	},
	setDroppedItem: function(droppedItem){
		//	
		// summary:
		//		sets the dropped item
		this._droppedItem = droppedItem;
	},
	getDroppedItem: function(){
		//	
		// summary:
		//		gets the dropped item
		return this._droppedItem;
	},
	setDroppedPosition: function(droppedPosition){
		//	
		// summary:
		//		sets the dropped position (graph coordinates)
		this._droppedPosition = droppedPosition;
	},
	getDroppedPosition: function(){
		//	
		// summary:
		//		gets the dropped position (graph coordinates)
		return this._droppedPosition;
	},
	setElementsList: function(elementsList){
		//	
		// summary:
		//		sets the elements list, that contains the graph elements that match to the dropped position
		this._elementsList = elementsList;
	},
	getElementsList: function(){
		//	
		// summary:
		//		gets the elements list, that contains the graph elements that match to the dropped position
		return this._elementsList;
	},
	setDropInteractor: function(dropInteractor){
		//	
		// summary:
		//		sets the drop interactor
		this._dropInteractor = dropInteractor;
	},
	getDropInteractor: function(){
		//	
		// summary:
		//		gets the drop interactor
		return this._dropInteractor;
	},
	redoFunction: function(){
		var newElements = this._getNewList();
		var di = this.getDropInteractor()
		eu.startDropAction(this.getDroppedItem(),this.getDroppedPosition(),di.getDiagram(),newElements,this);
	},
	_getNewList: function(){
		var newElements = [];
		var elements = this.getElementsList();
		dojo.forEach(elements, dojo.hitch(this, function(item){
			var newItem = this.getUndoManager().getRegisteredGraphElement(item);
			newElements.push(newItem);
		}));
		return newElements;
	}
	});
	
})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.DropInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.DropInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.DropInteractor');










(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var eu = ibm_ilog.diagram.editor.EditingUtils;

dojo.declare("ibm_ilog.diagram.editor.interactors.DropInteractor",[], {
	//
	//	summary:
	//		this interactor manage the drop actions on the DiagramEditor. For Simplicity,
	//		this interactor relies on dojo.dnd.manager() to manage all this behavior with a
	//		standard dojo method.
	//
	_diagram: null,
	_droppedItem: null,
	_connectorHandle: null,
	_dropable: null,
	_acceptedTypes:{},
	_onDropFunction: null,
	_onDropTemplateFunction: null,
	
	constructor: function(diagram,onDropFunction,onDropTemplateFunction){
		// Summary:
		//		Creates a new instance of dojo.dnd.Target associated to the diagram DOM node.
		//		Also sets the diagram, the onDropFunction and the onDropTemplateFunction
		this._diagram = diagram;
		this._dropable = new dojo.dnd.Target(this._diagram.domNode, {accept: []});
		this._dropable.onDrop = dojo.hitch(this,this._onDropNode);
		this.setOnDropFunction(onDropFunction);
		this.setOnDropTemplateFunction(onDropTemplateFunction);
	},
	activate: function(){
		// Summary:
		//		connects this class to the dojo.dnd.manager() onMouseUp function, to catch the event point.
		//		Sets the accepted types
		this._connectorHandle = dojo.connect( dojo.dnd.manager(),"onMouseUp",this,"_onMouseUpManager");
		this._dropable.accept = this._acceptedTypes;
		
	},
	deactivate: function(){
		// Summary:
		//		disconnects this class to the dojo.dnd.manager() onMouseUp function.
		//		Sets the accepted types to empty, to avoid any drop action
		dojo.disconnect(this._connectorHandle);
		this._dropable.accept = {};
	},
	isDropAction: function(){
		// Summary:
		//		return if a drop action is taking place
		return this._droppedItem != null;
	},
	setAcceptedTypes: function(types /*array*/){
		// Summary:
		//		sets the accepted types to be used in the Target element.
		//		The change take place when reactivating this class
		this._acceptedTypes = {};
			for(var i = 0; i < types.length; ++i){
				this._acceptedTypes[types[i]] = 1;
			}
	},
	setOnDropFunction: function(onDropFunction){
		// Summary:
		//		sets the onDropFunction. This function is called when a drop action occurs.
		this._onDropFunction = onDropFunction;
	},
	setOnDropTemplateFunction: function(onDropTemplateFunction){
		// Summary:
		//		sets the onDropTemplateFunction. This function is called to resolve the template when a drop action is taking place.
		this._onDropTemplateFunction = onDropTemplateFunction;
	},
	resolveNodeTemplate: function(dataItem){
		// Summary:
		//		called the onDropTemplateFunction with the given item, and the dropped item
		return this._onDropTemplateFunction?this._onDropTemplateFunction.call(null,this._droppedItem,dataItem,this._diagram):null;
	},
	setDroppedItem: function(droppedItem){
		this._droppedItem = droppedItem;
	},
	_onDropNode: function(source, nodes, copy){
		// Summary:
		//		function called when Target.onDrop is called
		//		Override that method
		this._droppedItem = source.getItem(nodes[0].id);
	},
	_onMouseUpManager: function(e){
		// Summary:
		//		function called when dojo.dnd.manager() "onMouseUp" is called
		//		In this method, the onDropFunction is called
		if(this.isDropAction()){
			var D = this._diagram;
			var V = D.getViewport();
			var GR = D.getGraph();
			var p = V.eventContentLocation(e);
			var elements = D.getGraph().hitTest(p);
			eu.startDropAction(this._droppedItem,p,D,elements,eu.createOnDropAction(D,this._droppedItem,p,elements));
			this._droppedItem = null;
		}
	},
	
	getDiagram: function(){
		return this._diagram;
	}
});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor');







dojo.declare("ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor manages the graphElements resizing through the keyboard interaction.
	//		This Interactor have 8 connections: reduceWidth, fineReduceWidth, increaseWidth, fineIncreaseWidth, 
	//		reduceHeight, fineReduceHeight, increaseHeight, fineIncreaseHeight.
	
	_diagram: null,
	_increment: null,
	_fineIncrement: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.		
		this._diagram = diagram;
		this.setIncrement(10);
		this.setFineIncrement(1);
		return this._initialize();
	},
	setIncrement: function(increment){
		// summary: 
		//		sets the resize increment
		// increment: integer
		//		the increment to be set
		this._increment = increment;
	},
	getIncrement: function(){
		// summary: 
		//		gets the resize increment
		return this._increment;
	},
	setFineIncrement: function(increment){
		// summary: 
		//		sets the resize fine increment
		// increment: integer
		//		the fine increment to be set
		this._fineIncrement = increment;
	},
	getFineIncrement: function(){
		// summary: 
		//		gets the resize fine increment
		return this._fineIncrement;
	},
	reduceHeight: function(e){
		// summary: 
		//		Reduces the focused element height from the right bottom corner
		this._resize({x:0,y:-this._increment});
	},
	increaseHeight: function(e){
		// summary: 
		//		Increases the focused element height from the right bottom corner
		this._resize({x:0,y:this._increment});
	},
	increaseWidth: function(e){
		// summary: 
		//		Increases the focused element width from the right bottom corner
		this._resize({x:this._increment,y:0});
	},
	reduceWidth: function(e){
		// summary: 
		//		Reduces the focused element width from the right bottom corner
		this._resize({x:-this._increment,y:0});
	},
	fineReduceHeight: function(e){
		// summary: 
		//		Finely reduces the focused element height from the right bottom corner
		this._resize({x:0,y:-this._fineIncrement});
	},
	fineIncreaseHeight: function(e){
		// summary: 
		//		Finely increases the focused element height from the right bottom corner
		this._resize({x:0,y:this._fineIncrement});
	},
	fineIncreaseWidth: function(e){
		// summary: 
		//		Finely increases the focused element width from the right bottom corner
		this._resize({x:this._fineIncrement,y:0});
	},
	fineReduceWidth: function(e){
		// summary: 
		//		Finely reduces the focused element width from the right bottom corner
		this._resize({x:-this._fineIncrement,y:0});
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		return ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			reduceWidth: {
				hotKey: dojo.keys.LEFT_ARROW,
				connectTo: "reduceWidth",
				filter: this._buildInputFilter({ctrl:true,shift:false})
			}, fineReduceWidth: {
				hotKey: dojo.keys.LEFT_ARROW,
				connectTo: "fineReduceWidth",
				filter: this._buildInputFilter({ctrl:true,shift:true})
			}, increaseWidth: {
				hotKey: dojo.keys.RIGHT_ARROW,
				connectTo: "increaseWidth",
				filter: this._buildInputFilter({ctrl:true,shift:false})
			}, fineIncreaseWidth: {
				hotKey: dojo.keys.RIGHT_ARROW,
				connectTo: "fineIncreaseWidth",
				filter: this._buildInputFilter({ctrl:true,shift:true})
			}, reduceHeight: {
				hotKey: dojo.keys.UP_ARROW,
				connectTo: "reduceHeight",
				filter: this._buildInputFilter({ctrl:true,shift:false})
			}, fineReduceHeight: {
				hotKey: dojo.keys.UP_ARROW,
				connectTo: "fineReduceHeight",
				filter: this._buildInputFilter({ctrl:true,shift:true})
			}, increaseHeight: {
				hotKey: dojo.keys.DOWN_ARROW,
				connectTo: "increaseHeight",
				filter: this._buildInputFilter({ctrl:true,shift:false})
			}, fineIncreaseHeight: {
				hotKey: dojo.keys.DOWN_ARROW,
				connectTo: "fineIncreaseHeight",
				filter: this._buildInputFilter({ctrl:true,shift:true})
			}
		};
	},
	_resize: function(delta){
		var ge = this._diagram.getFocusedElement();
		if(ge && !ge._IBMDiagramLink){
			var startBB = ge.getBounds();
			var endBB = ibm_ilog.diagram.util.Geometry.cloneRect(startBB);
			var min = ge.minimumSize;
		
			endBB.width = Math.max(min.width,startBB.width + delta.x);
			endBB.height = Math.max(min.height,startBB.height + delta.y);
		
			ge.setBounds(endBB);
			this._diagram.getUndoManager().addAction(this._createUndoAction(ge, startBB, endBB));
		}
	},
	_createUndoAction: function(ge, startBB, endBB){
		var action = new ibm_ilog.diagram.editor.undo.SimpleAction(ibm_ilog.diagram.editor.undo.UndoActionList.Resize);
		action.setOldValue(startBB);
		action.setNewValue(endBB);
		action.setMethodOrProperty('setBounds');
		action.setModifiedElementId(ge.getId());
		return action;
	}
});

ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor.KeyInteractorId = "Resize";

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor');










(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var gu = ibm_ilog.diagram.util.GraphUtil;
	var m = dojox.gfx.matrix;
	
dojo.declare("ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor manages the graphElements deletion through the keyboard interaction.
	//		This Interactor have 2 connections: deleteDelete, deleteBackSpace. Both connections calls the same delete method.
	_diagram: null,
	_serializer: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.editor.DiagramEditor
    //		the associated diagram editor.		
		this._diagram = diagram;
		return this._initialize();
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		return ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			deleteDelete: {
			hotKey: dojo.keys.DELETE,	
			connectTo: "doDelete"
			}, deleteBackSpace: {
				hotKey: dojo.keys.BACKSPACE,
				connectTo: "doDelete"
			}
		};
	},
	
	doDelete: function(){
		// summary:
		//		Deletes the selected elements and all the connected links. If none selected,
		//		removes the focused element and all connected links.
		var targetSet = this._buildTargetSet();
		return targetSet ? this._diagram.deleteGraphElements(targetSet) : false;
	},
	
	_buildTargetSet: function(){
		//
		//	summary:
		//		Builds the set of entities that are going to be affected by the delete action.
		//
		//	description:
		//		gets the selected object and iterate over them to add all the children and 
		//		connected nodes to to deletion target set.
		//		If no element is selected, the target set is created based on the focused object.
		var selection = this._diagram.getSelection();
		var s = selection.fastGet().toArray();
		var targetSet = null;
		
		if(s.length == 0){
			var c = this._diagram.getFocusedElement();
			if(c){
				targetSet = [c];
			}else{
				return null;
			}
		}else{
			targetSet = s;
		}
		return targetSet;
	}
});

ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor.KeyInteractorId = "Delete";
})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor');







(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var gu = ibm_ilog.diagram.util.GraphUtil;
	var m = dojox.gfx.matrix;
	
dojo.declare("ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor connects two or more Nodes through the keyboard interaction.
	//		This Interactor have 1 connection: connect.
	
	_diagram: null,
	_linkShapeType: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.		
		this._diagram = diagram;
		return this._initialize();
		var linkStyle = this._viewport.getDiagram().linkStyle;
		this._linkShapeType = linkStyle?linkStyle.shapeType:ibm_ilog.diagram.LinkShapeType.Straight;
	},
	setLinkShapeType: function(linkShapeType){
		// Summary:
		//		sets the link shape type
		this._linkShapeType = linkShapeType;
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		return ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			connect: {
			hotKey: 74,/* j key */	
			connectTo: "connect",
			filter: this._buildInputFilter({ctrl:true,shift:false})
			}
		};
	},
	connect: function(e){
		// Summary:
		//		connects all the selected nodes in the order that they are selected.
		//		If there is a link in the selection or there is just one element selected, this function does nothing.
		var sel = this._diagram.getSelection().get();
		var linkSelection = false;
		var nodeSelection = false;
		var D = this._diagram;
		sel.forEach(function(elem){
			elem = D.asGraphElement(elem);
			if(elem._isIBMDiagramLink){
				linkSelection = true;
			}else{
				nodeSelection = true;
			}
		});
		if(linkSelection && nodeSelection){
			return false;
		}else{
			if(linkSelection){
				return this.invertLinks(sel);
			}else{if(nodeSelection){
				return this.connectNodes(sel);
			}}
		}
	},
	
	invertLinks: function(sel){
		if(sel.count < 1){
			return false;
		}
		var mAction = new ibm_ilog.diagram.editor.undo.MultipleAction(ibm_ilog.diagram.editor.undo.UndoActionList.InvertLink);
		for(var index = 0;index <sel.count;index++){
			var link = sel.item(index);
			var a = ibm_ilog.diagram.editor.EditingUtils.invertLink(link);
			mAction.addAction(a);
		}
		var um = this._diagram.getUndoManager();
		um.addAction(mAction);
		
		return true;
	},
	connectNodes: function(sel){
		if(sel.count < 2){
			return false;
		}
		var mAction = new ibm_ilog.diagram.editor.undo.MultipleAction(ibm_ilog.diagram.editor.undo.UndoActionList.Connect);
		var links = [];
		var added = 0;
		for(var index = 1;index <sel.count;index++){
			var a = this._doConnect(sel.item(index-1),sel.item(index),links);
			if(a){
				mAction.addAction(a);
				added++;
			}
		}
		if(added>0){
			var um = this._diagram.getUndoManager();
			um.addAction(mAction);
			this._diagram.getSelection().add(links,true);
		}
		
		return true;
	},
	_doConnect: function(start,end,links) {
		//	summary:
		//			
		if(this._diagram.allowCreateLink(start,end)){
			var link = this._diagram.connectNodes(start,end);
			links.push(link);
			var parent = link.getParent();
			var undoAction = this._createConnectUndoAction(this._diagram,link,parent);
			this._diagram.onLinkUpdated(this._diagram,link,true,undoAction);
			return undoAction;
		}else{
			//TODO add onMessage call
			return null;
		}
	},
	_createConnectUndoAction: function(diagram,link,parent){
		var action = new ibm_ilog.diagram.editor.undo.ConnectAction(diagram,link,parent);
		return action;
	}
});

ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor.KeyInteractorId = "Connect";
})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor');




dojo.declare("ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor manages the Clipboard through the keyboard interaction.
	//		This Interactor have 3 connections: cut, copy, paste.
	
	_diagram: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.		
		this._diagram = diagram;
		return this._initialize();
	},
	copy: function(e){
		// summary:
	    //		This method calls the Clipboard Copy function.
		this._diagram.getClipboard().copy();
	},
	paste: function(e){
		// summary:
	    //		This method calls the Clipboard Paste function. The pasteObject is the focused element if it is a subgraph, or its parent if other.
		//		If there is no focused element, the paste action is done in the top level graph. The paste position is set to {x:0,y:0} but the pasted 
		//		elements remains selected to easily move them.
		
		var clipboard = this._diagram.getClipboard();
		var container = this._diagram.getFocusedElement();
		if(container){
			if(container._isIBMDiagramSubgraph){
				container = container.getGraph();
			}else{
				container = container.getParent();
			}
		}else{
			container = this._diagram.getGraph();
		}
		
		clipboard.paste(container);
	},
	cut: function(e){
		// summary:
	    //		This method calls the Clipboard Cut function.
		this._diagram.getClipboard().cut();
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		return ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			copy: {
				hotKey: 67,//  letter C	
				connectTo: "copy",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}, paste: {
				hotKey: 86,//  letter V
				connectTo: "paste",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}, cut: {
				hotKey: 88,//  letter X
				connectTo: "cut",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}
		};
	}
});

ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor.KeyInteractorId = "Clipboard";

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor');




dojo.declare("ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor manages the UndoManager through the keyboard interaction.
	//		This Interactor have 2 connections: undo, redo.
	
	_diagram: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.		
		this._diagram = diagram;
		return this._initialize();
	},
	undo: function(e){
		// summary:
	    //		this methods calls the UndoManager undoAction function.
		this._diagram.getUndoManager().undoAction();
	},
	redo: function(e){
		// summary:
	    //		this methods calls the UndoManager redoAction function.
		this._diagram.getUndoManager().redoAction();
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		return ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			redo: {
				hotKey: 89,//  letter Y
				connectTo: "redo",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}, undo: {
				hotKey: 90,//  letter Z
				connectTo: "undo",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}
		};
	}
});

ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor.KeyInteractorId = "UndoManager";

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor');




dojo.declare("ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor edit the first editable label through the keyboard interaction.
	//		This Interactor have 1 connection: editInlineText.
	
	_diagram: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.			
		this._diagram = diagram;
		return this._initialize();
	},
	editInlineText: function(e){
		// summary:
		//		opens the inline editor of the first editable label of the focused graph element
		var ge = this._diagram.getFocusedElement();
		if(ge && !ge._isIBMDiagramLink){	
			var es = this._diagram.getEditables(ge);
			if(es && es.length) {
				this._diagram.openEditableInlineEditor(es[0]);
			}
		}
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		
		return ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			editInlineText: {
				hotKey: dojo.keys.F2,
				connectTo: "editInlineText"
			}
		};
	},
	
	__eod: undefined
});

ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor.KeyInteractorId = "InlineEditor";

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.DiagramEditor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.DiagramEditor'] = true;
dojo.provide('ibm_ilog.diagram.editor.DiagramEditor');






















 // [av] temporary, move to Diagram after prototyping?.







(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
	
	dojo.declare("ibm_ilog.diagram.editor.DiagramEditor", [ibm_ilog.diagram.widget.Diagram], {
		//
		//	summary:
		//		This is an extension of the Diagram Dijit that provides editing capabilities.
		//
		//	description:
		//		In addition to the services from Diagram, this widget includes the following services:
		//
		//		- Can be a drag and drop target (look at samples/dnd/dnd.html)
		//		- Node/Subgraph resizing through adorners
		//		- Link creation and editing through adorners
		//
		_isIBMDiagramEditor: true,
		
		dropable: null,
		
		//
		//	allowFreeLinks: [markup] boolean
		//		this value determine if the interactors can create free links
		//		
		allowFreeLinks: null,
		
		//
		//	onDropFunction: [markup] function
		//		This function is called on diagram drop action
		//		format: DropFunction(droppedItem,point,Diagram,overElements,undoAction)
		//		
		onDropFunction: null,
		
		//
		//	onDropTemplateFunction: [markup] Boolean
		//		this function is called to determine the template on drop action
		// 		format: DropTemplateFunction(droppedItem,dataItem,diagram)
		//		
		onDropTemplateFunction: null,
		
		//
		//	allowCreateLinkFunction: [markup] function
		//		This function is called to know if it is allowed to create a new link between two nodes
		//		return true by default.
		//		format: allowCreateLinkFunction(DiagramEditor, startNode, endNode)
		//		
		allowCreateLinkFunction: null,
		
		//
		//	allowCreateNodeFunction: [markup] Boolean
		//		This function is called to know if it is allowed to create a new node
		//		return true by default.
		//		format: allowCreateNodeFunction(DiagramEditor, parentNode, childNode)
		allowCreateNodeFunction: null,
		
		
		//
		//  move: [markup] boolean
		//      enable or disable moving entities (true by default at DiagramEditor)
		//
		move: true,
		
		//	summary:
		//		Used to disable the initialization of inline-editable fields in the templates, lowering graphic overhead.
		//
		disableInlineEditors: false,
		
		// undoManager: this variables contains the UndoManager instance
		_undoManager: null,
		
		_adornersInitialized: false,
		_resizeAdorner: null,
		_connectionAdorner: null,
		_linkConnectionAdorner: null,
		_linkIntermediatePointsAdorner: null,
		
		enableDropable: function(enabled){
			if (this.dropable == null) {
				this.dropable = new ibm_ilog.diagram.editor.interactors.DropInteractor(this, this.onDropFunction, this.onDropTemplateFunction);
			}
			if (enabled) {
				this.dropable.activate();
			} else {
				this.dropable.deactivate();
			}
		},
		
		postMixInProperties: function(){
			this.inherited(arguments);
			this._inlineEditors = new dojox.collections.Dictionary();
		},
		
		postPostCreate: function(){
			dojo.connect(this, "onNodeCreated", this, "_editorNodeCreated");
			dojo.connect(this, "onLinkCreated", this, "_editorLinkCreated");
			dojo.connect(this, "onSubgraphCreated", this, "_editorSubgraphCreated");
		},
		
		reset: function(){
			this.inherited(arguments);
			this._undoManager.reset();
			this._clipboard.clear();
		},
		
		// ========================================================================================================
		//
		//	INTERACTORS:
		//
		
		getAssociatedLinkAdornersFunction: function(ge){
			if (this._adornersInitialized) {
				return [this._linkConnectionAdorner, this._linkIntermediatePointsAdorner];
			} else {
				return [];
			}
		},
		
		getAssociatedNodeAdornersFunction: function(ge){
			if (this._adornersInitialized) {
				return [this._resizeAdorner, this._connectionAdorner];
			} else {
				return [];
			}
		},
		
		getAssociatedSubgraphAdornersFunction: function(){
			if (this._adornersInitialized) {
				if (dojo.config.useGfxLayout) {
					return [this._connectionAdorner];
				} else {
					return [this._resizeAdorner, this._connectionAdorner];
				}
			} else {
				return [];
			}
		},
		
		_initializeInteractors: function(){
			//
			//	summary:
			//		Initializes the interactors used by the Diagram
			//
			this._initializeUndoManager();
			
			this._initializeClipboard();
			
			this.inherited(arguments);
			
			this.enableDropable(true);
			
		},
		
		_initializeKeyInteractors: function(){
			//
			//	tags:
			//		private
			//
			this.inherited(arguments);
			
			this._keyInteractors.add(ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor.KeyInteractorId, new ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor().initialize(this));
			
			this._keyInteractors.add(ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor.KeyInteractorId, new ibm_ilog.diagram.editor.interactors.DeleteKeyInteractor().initialize(this));
			
			this._keyInteractors.add(ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor.KeyInteractorId, new ibm_ilog.diagram.editor.interactors.ConnectionKeyInteractor().initialize(this));
			
			this._keyInteractors.add(ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor.KeyInteractorId, new ibm_ilog.diagram.editor.interactors.ClipboardKeyInteractor().initialize(this));
			
			this._keyInteractors.add(ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor.KeyInteractorId, new ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor().initialize(this));
			
			this._keyInteractors.add(ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor.KeyInteractorId, new ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor().initialize(this));
			
			var edition = this._keyInteractors.get(ibm_ilog.diagram.interactors.SwitchModeInteractor.KeyInteractorId);
			edition.addEditionInteractorId(ibm_ilog.diagram.editor.interactors.ResizeKeyInteractor.KeyInteractorId);
			edition.enterNavigation();
			
		},
		
		_initializeUndoManager: function(){
			this._undoManager = new ibm_ilog.diagram.editor.undo.UndoManager(this);
		},
		
		registerInlineEditor: function(id, editor){
			//
			//	summary:
			//		Registers a new inline editor with a certain id.
			//	id: string
			//		The associated id for referencing the editor from editable attachpoints at graph element templates.
			//	editor: ibm_ilog.diagram.editor.adorners.TextEditAdorner
			//		The adorner used as editor.
			this._inlineEditors.add(id, editor);
		},
		
		_createAdorners: function(){
			this.inherited(arguments);
			this._resizeAdorner = this.createAdorner(ibm_ilog.diagram.editor.adorners.ResizeAdorner, this._adornerTemplates, "ResizeAdorner");
			this._connectionAdorner = this.createAdorner(ibm_ilog.diagram.editor.adorners.ConnectionAdorner, this._adornerTemplates, "ConnectionAdorner");
			this._linkIntermediatePointsAdorner = this.createAdorner(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAdorner, this._adornerTemplates, "LinkIntermediatePointsAdorner");
			this._linkConnectionAdorner = this.createAdorner(ibm_ilog.diagram.editor.adorners.LinkConnectionAdorner, this._adornerTemplates, "LinkConnectionAdorner");
			this.registerInlineEditor("textbox", this.createAdorner(ibm_ilog.diagram.editor.adorners.TextEditAdorner, this._adornerTemplates, "TextEditAdorner"));
			this.getInlineEditorId("textbox").textbox.prepare(this.canvasNode);
			this._adornersInitialized = true;
		},
		
		enterStandardMode: function(){
			//
			//	summary:
			//		TODO TBD. Probably to be renamed also
			//    	
			this._interactors.switchTo("move", "select", "pan", "zoom", "focus", "adorners", "marquee", "wheelPan");
			
		},
		resolveNodeTemplate: function(item){
			// summary:
			//    Returns the template to represent the specified node item.
			//    item: dojo.data.Item: the node data item.
			var dropTemplate = (this.dropable && this.dropable.isDropAction()) ? this.dropable.resolveNodeTemplate(item) : null;
			return dropTemplate != null ? dropTemplate : this.inherited(arguments);
			
		},
		setAcceptedDropTypes: function(types){
			// summary:
			//    Sets the accepted types to be dropped.
			if (this.dropable != null) {
				this.dropable.setAcceptedTypes(types);
				this.enableDropable(false);
				this.enableDropable(true);
			}
		},
		
		getDropInteractor: function(){
			// summary:
			//    return the drop interactor
			return this.dropable;
		},
		
		onLinkUpdated: function(diagram, link, isNew, undoAction){
			// sumamry:
			//		The user must connect to this function to create the link in the linkstore or customize the created link.
			// diagram: ibm_ilog.diagram.editor.DiagramEditor
			//		this is the DiagramEditor instance.
			// link: ibm_ilog.diagram.Link
			//		the updated link.
			// isNew: boolean
			//		identify if the link is recently created (true) or just modified (false).
			// undoAction: ibm_ilog.diagram.editor.undo.Action
			//		the Action that take place in this edition
		},
		
		allowCreateLink: function(startNode, endNode){
			// summary:
			//		evaluates if the link between two nodes can be created, based on the allowCreateLinkFunction
			// startNode: ibm_ilog.diagram.Node
			//		the possible link start node
			// enNode: ibm_ilog.diagram.Node
			//		the possible link end node
			return this.allowCreateLinkFunction ? this.allowCreateLinkFunction.call(null, this, startNode, endNode) : true;
		},
		
		allowCreateNode: function(parent, child){
			// summary:
			//		evaluates if the nodes can be created, based on the allowCreateLinkFunction
			// parent: ibm_ilog.diagram.Node
			//		the possible parent of the node
			// child: ibm_ilog.diagram.Node
			//		the created node
			return this.allowCreateNodeFunction ? this.allowCreateNodeFunction.call(null, this, parent, child) : true;
		},
		
		getUndoManager: function(){
			// summary:
			//		return the private instance of ibm_ilog.diagram.editor.undo.UndoManager
			return this._undoManager;
		},
		
		getAllowFreeLinks: function(){
			// summary:
			//		This method is deprecated from 1.1. Use dojo.get('allowFreeLinks') instead.
			//		true, if the diagram allow free links (links with no end or start node)
			return this.allowFreeLinks ? this.allowFreeLinks : false;
		},
		
		setAllowFreeLinks: function(allowFreeLinks){
			// summary:
			//		This method is deprecated from 1.1. Use dojo.set('allowFreeLinks', value) instead.
			//		Sets if the diagram allow free links (links with no end or start node)
			// allowFreeLinks: boolean
			// 		true, if the diagram allow free links (links with no end or start node)
			this.allowFreeLinks = allowFreeLinks;
		},
		
		
		// ========================================================================================================
		//
		//	INLINE EDITORS:
		//
		
		//
		//	defaultEditableRegionStyle:
		//		The style to be used for the editable region
		//
		defaultEditableRegionStyle: {
			fill: [0, 0, 0, 0.001],
			selectedStyle: {
				stroke: {
					style: 'ShortDot',
					color: 'black'
				}
			}
		},
		
		_isAttachPointEditable: function(a){
			//	summary:
			//		returns true if an attachPoint has a valid editable region information 
			//	a: the component
			return (a.shape.type == "text" || a.shape.type == "mltext") && a.editable && a.editable.editor && this._inlineEditors.contains(a.editable.editor) && (a.editable.id || (a.editable.getter && a.editable.setter));
		},
		
		_getEditableRegionBoundingBox: function(a){
			//	summary:
			//		returns the bounding box of the editable component
			//	a: the component that was declared editable
			var empty = EmptyRect, bb = a.getBoundingBox(), ed = a.editable;
			if (ed.baseRegion) {
				if (!bb) {
					bb = ed.baseRegion;
				} else {
					bb = g.addRect(bb, ed.baseRegion);
				}
			}
			if (ed.minRegionSize) {
				if (!bb) {
					bb = g.standarizeRect(ed.minRegionSize);
				} else {
					var w = ed.minRegionSize.width;
					var h = ed.minRegionSize.height;
					if (w) {
						bb = g.rectCenteredOverride(bb, {
							width: Math.max(w, bb.width)
						});
					}
					if (h) {
						bb = g.rectCenteredOverride(bb, {
							height: Math.max(h, bb.height)
						});
					}
				}
			}
			if (!bb) 
				bb = empty;
			var tr = a.getTransform();
			if (tr) {
				bb = tr.transformRectangle(bb);
			}
			if (ed.border && bb) {
				bb = g.expandRect(bb, ed.border);
			}
			return bb || empty;
		},
		
		_onEditableTextChanged: function(a, ge, er){
			//	summary:
			//		updates the editable region shape when its bounds have changed
			//	a: the component that was declared editable
			//	ge: the graph element
			//	er: the editable region shape
			
			if (dojo.isIE > 7 && ibm_ilog.diagram.isVml && er.__ie8Handler !== undefined) {
				// dispose the handler set to solve ie8/vml setShape issue (see _createEditableRegionShape)
				er.disconnect(er.__ie8Handler);
			}
			er.setShape(this._getEditableRegionBoundingBox(a));
			if(er.computePreferredSize) er.computePreferredSize({width:-1, height:-1});
		},
		
		_createEditableRegionShape: function(a, ge){
			//	summary:
			//		created the editable region shape associated with an editable component
			//	a: the component that was declared editable
			//	ge: the graph element
			var editable = a.editable;
			var bb = this._getEditableRegionBoundingBox(a);
			var editableBaseShape = a.parent.createRect(bb);
			
			var style = dojo.clone(this.defaultEditableRegionStyle || {});
			dojo.mixin(style, editable.regionStyle);
			
			gu.applyStyle(editableBaseShape, style);
			
			if (editable.layoutProperties) 
				dojo.mixin(editableBaseShape, editable.layoutProperties);
			
			if (dojox.gfx.renderer == "silverlight") {
				editableBaseShape.connect("onclick", this, function(){
					this._openInlineEditor(ge, a, editableBaseShape);
				});
			} else {
				editableBaseShape.connect("ondblclick", this, function(){
					this._openInlineEditor(ge, a, editableBaseShape);
				});
			}
			
			if (dojo.isIE > 7 && ibm_ilog.diagram.isVml){
				dojo.connect(editableBaseShape, 'setShape', this, function(){
					// in IE8/VML Rect.setShape creates a new rawNode. need to update the connections
					editableBaseShape.__ie8Handler = editableBaseShape.connect("ondblclick", this, function(){
						this._openInlineEditor(ge, a, editableBaseShape);
					});
				});
			}

			
			return editableBaseShape;
		},
		
		getInlineEditorId: function(id){
			//	summary:
			//		returns the inline editor registered with the given id
			return this._inlineEditors.item(id);
		},
		
		_openInlineEditor: function(ge, a, editableBaseShape){
			//	summary:
			//		opens an inline editor on the component a of graph element ge
			//	ge: the graph element
			//	a: the editable attachpoint
			//	editableBaseShape: the editable region shape
			this.visualizeBounds(ge, {
				expandCurrent: true
			});
			
			var e = this.getInlineEditorId(a.editable.editor), set, get;
			
			if (a.editable.id) {
				var uname = (a.editable.id.substr(0, 1).toUpperCase()) + a.editable.id.substr(1);
				get = "get" + uname;
				set = "set" + uname;
			} else {
				get = a.getter;
				set = a.setter;
			}
			if (a.editable.options) {
				e.setOptions(a.editable.options);
			}
			e.setAccessors(function(adorned){
				return adorned[get]();
			}, function(adorned, value){
				adorned[set](value);
			});
			
			e.setComponentAttachPoint(a);
			e.setComponent(editableBaseShape);
			e.setAdorned(ge);
		},
		
		initializeEditables: function(ge){
			//	summary:
			//		scan the attachpoints of graph element ge in search for editable 
			//		fields initialize the corresponding infrastructure to allow editing.  
			//	ge: the graph element
			if (!this.disableInlineEditors) {
				var maybeEditables = ge._attachPoints;
				dojo.forEach(ge._attachPoints, function(id){
					var a = ge[id];
					if (this._isAttachPointEditable(a)) {
						try {
							var editableBaseShape = this._createEditableRegionShape(a, ge);
							var textChanged = function(){
								this._onEditableTextChanged(a, ge, editableBaseShape);
							};
							
							// TODO need a.onChange here
							ge.addConnection(dojo.connect(a, "setShape", this, textChanged));
							ge.addConnection(dojo.connect(a, "setFont", this, textChanged));
							if (a.applyLayout) 
								ge.addConnection(dojo.connect(a, "applyLayout", this, textChanged));
							if (ge._isIBMDiagramSubgraph) {
								ge.addConnection(dojo.connect(ge, "onCollapsedChanged", this, textChanged));
							}
							ge.__editables = (ge.__editables || []);
							ge.__editables.push({
								ge: ge,
								attach: a,
								base: editableBaseShape
							});
						} catch (e) {
							R.warn("Wrapped", "DiagramEditor.js # initializeEditables", e);
						}
					}
				}, this);
			}
		},
		
		getEditables: function(ge){
			//
			//	summary:
			//		Return the editable attachpoints of a graph element
			//	ge:
			//		ibm_diargram.GraphElement
			//	returns:
			//		The set of the editable attachpoint belonging to a graph element.
			//
			return ge.__editables;
		},
		
		openEditableInlineEditor: function(editable){
			//
			//	summary:
			//		Open the inline editor associated with a graph element editable attachpoint.
			//	editable: {ge:,attach:,base:}
			//		The editable attachpoint belonging to a graph element.
			//
			this._openInlineEditor(editable.ge, editable.attach, editable.base);
		},
		
		_editorNodeCreated: function(node, diagram){
			this.initializeEditables(node);
		},
		
		_editorSubgraphCreated: function(subgraph, diagram){
			this.initializeEditables(subgraph);
		},
		
		_editorLinkCreated: function(link, diagram){
			this.initializeEditables(link);
		},
		
		// ========================================================================================================
		//
		//	CLIPBOARD:
		//
		_clipboard: null,
		
		_initializeClipboard: function(){
			this._clipboard = new ibm_ilog.diagram.editor.Clipboard(this);
		},
		getClipboard: function(){
			// summary:
			//		return the private instance of ibm_ilog.diagram.editor.Clipboard
			return this._clipboard;
		},
		
		// =========================================================================================================
		//
		//	RemoveSerializer:
		// 
		
		_removeSerializer: null,
		
		_getRemoveSerializer: function(){
			var thiz = this;
			if (!this._removeSerializer) {
				var notificationObject = {
					diagram: thiz,
					onSerialize: function(graphElement, serializedData){
					},
					onDeserialize: function(serializedData, newGraphElement, container, undoAction){
						var um = this.diagram.getUndoManager();
						um.registerGraphElementReplacement(serializedData.id, newGraphElement.getId());
					}
				};
				this._removeSerializer = new ibm_ilog.diagram.editor.DiagramSerializer(this, null, notificationObject);
			}
			return this._removeSerializer;
		},
		
		// doDeleteFunction: Function
		// An optional function that handles delete operation and returns a corresponding Action
		// to be added to the undo manager (see ibm_ilog.diagram.editor.undo.Action). If no function
		// is specified, the default behavior is to remove and dispose the graphical shapes from the diagram
		// without any datastore-related considerations.
		// The function receives the following parameters:
		//		diagram: ibm_ilog.diagram.widget.Diagram. The diagram containing the elements to remove.
		//		elements: ibm_ilog.diagram.GraphElement. The graphical elements to delete.
		// The function must returns a ibm_ilog.diagram.editor.undo.Action instance that matches the function implementation (aka:
		// capable of undoing the deletion).
		doDeleteFunction : null,
		
		deleteGraphElements: function(/*ibm_ilog.diagram.GraphElement[]*/elements){
			// summary:
			//		Deletes the selected elements and all the connected links. 
			// description:
			//		This method should be invoked to delete the specified elements from the diagram and handles the 
			//		interface with the undo manager. The way the delete operation
			//		itself is performed may be customized by setting the doDeleteFunction property to a custom implementation. The
			//		default implementation removes and disposes the graphical shapes from the diagram without any datastore-related
			//		considerations. If you need to change this behavior, set this property so that it gets invoked instead of the default implementation.
			// elements: ibm_ilog.diagram.GraphElement[]
			// 		The elements to delete.
			// returns:
			//		true if the deletion could be performed, false otherwise.
		
			if (elements) {
				var action = ibm_ilog.diagram.editor.EditingUtils.deleteGraphElements(this, elements, this.doDeleteFunction);
				var um = this.getUndoManager();
				um.addAction(action);
				return true; // Boolean
			}
			return false; // Boolean
		},
		
		// marks the end of definition to make life easier with trailing '},'...
		__eod: null
	});
	
})();

}

if(!dojo._hasResource['ibm_ilog.diagram.editor.interactors.RotateHandleInteractor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.editor.interactors.RotateHandleInteractor'] = true;
dojo.provide('ibm_ilog.diagram.editor.interactors.RotateHandleInteractor');






(function () {
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;

dojo.declare("ibm_ilog.diagram.editor.interactors.RotateHandleInteractor", [ibm_ilog.diagram.interactors.DragInteractor], {
	//
	//	summary:
	//		This is a sample interactor. It allows to rotate the entities much like 
	//		the resize adorner resizes them. It works if connected to the ResizeHandles like the
	//		ResizeHandleInteractor is connected.
	//	

	//	
	//	_handle: /*ibm_ilog.diagram.editor.adorners.ResizeHandle*/
	//	
	_handle: null,

	initialize: function ( /* ibm_ilog.diagram.editor.adorners.ResizeHandle */ handle) {
		this._handle = handle;
		this._viewport = handle.getViewport();
		this._initialize();
		return this;
	},

	_getInitialEventSource: function () {
		return this._handle;
	},

	activate: function () {
		var a = this._handle._adorner;
		if(a._adorned) {
			this._transform = a._adorned.getTransformToContainer(a._viewport.getSurface()).inverse();
		}
		this.inherited(arguments);
	},

	getDefaultConnections: function () {
		var map = this.inherited(arguments);
		map.start = {
			src: this._getInitialEventSource(),
			srcEvt: "onmousedown",
			connectTo: "_dragPreStart",
			filter: this._buildInputFilter({shift:true,button:0}),
			gfxConnect:true
		};
		return map;
	},

	_getPivot: function (ge) {
		return g.getRectCenter(ge.getBounds());
	},

	_getAngle: function (pivot, p) {
		return Math.atan2(p.x - pivot.x, p.y - pivot.y);
	},

	_dragMove: function () {
		this.inherited(arguments);

		var ge = this._handle._adorner._adorned;
		var p = this._getPivot(ge);
		var a2 = this._getAngle(this._current, p);
		var a1 = this._getAngle(this._last, p);
		ge.applyLeftTransform(m.rotateAt(a1 - a2, p));
	}

});

})();

}

if(!dojo._hasResource['ibm_ilog.diagram.layer_editing']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.diagram.layer_editing'] = true;
dojo.provide('ibm_ilog.diagram.layer_editing');






















































}

