dojo.provide('ibm_ilog.diagram.overview.OverviewInteractor');

dojo.require('ibm_ilog.diagram.interactors.Interactor');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.util.Geometry');

(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var dojex = ibm_ilog.diagram._base.dojoext;

	ibm_ilog.diagram.overview.OverviewInteractorMixin = {

		//
		//	summary:
		//		Abstract class with the basic behavior of an interactor which handles input into an Overview.
		//
		
		//
		//	_viewport: ibm_ilog.diagram.widget.Viewport
		//		The diagram viewport
		//
		_viewport: null,

		//
		//	_viewport: ibm_ilog.diagram.overview
		//		The overview
		//
		_overview: null,
		
		//
		//	_surface: dojox.gfx.Surface
		//		The surface
		//
		_surface: null,

		initialize: function( /*ibm_ilog.diagram.widget.Viewport*/viewport, /*ibm_ilog.diagram.overview*/ overview, /*dojox.gfx.Surface*/ surface ) {
			this._viewport = viewport;
			this._overview = overview;
			this._surface = surface;
			this._initialize();
			return this;
		},
		
		eventSurfaceLocation: function (e) {
			//
			//	Returns the client location of a mouse event generated by the event source
			//
			var r = dojex.coords(this._surface._parent, true);
			return {
				x: e.pageX - r.x,
				y: e.pageY - r.y
			};
		},		

		eventViewportLocation: function( /*Event*/ e ) {
			//
			//	summary:
			//		Returns the event location in content coordinates
			//
			var loc = this.eventSurfaceLocation(e);
			return this._overview.clientToContent().transformPoint(loc);
		}

	};
	
	dojo.declare("ibm_ilog.diagram.overview.OverviewInteractor", [ibm_ilog.diagram.interactors.Interactor],ibm_ilog.diagram.overview.OverviewInteractorMixin);

})();