/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

require({cache:{
'ibm_ilog*graphlayout/random/RandomLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/basic/BasicLinkStyleLayout","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LinkStyles"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.random.RandomLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.random.RandomLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LinkStyles');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.random.RandomLayout', ibm_ilog.graphlayout.basic.BasicLinkStyleLayout, 
{
  // summary:
  //		The main class for the Random Layout algorithm. 
  // description:
  //		The main class for the Random Layout algorithm. 
  //		<p>
  //		This is the simplest layout algorithm. The nodes are moved at
  //		randomly-computed positions inside a user-defined region which can be
  //		specified using the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.layoutRegion</code>.  
  //		</p>
  //		<p>
  //		Sample drawing produced by the Random Layout algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-17-cycles-before.gif" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the User Manual for details on the
  //		algorithm, the types of graphs for which this algorithm can be used,
  //		features and limitations, code samples, and so on.  
  //		</p>
  //		<p>
  //		Note that the initial position of the nodes (at the moment you start
  //		the layout) does not affect the resulting layout. However, nodes
  //		specified as fixed are not moved if you call the method <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedNodes()</code> with
  //		a <code>true</code> argument.  
  //		</p>
  /*=====
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are given a straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are not reshaped.
  NO_RESHAPE_STYLE : null,
  =====*/
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.  
    //		</p>
    // tags:
    //		protected
    
    this.inherited("init", arguments, []);
  },

  constructor : function(source )
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout on a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the link clip and link connection box interfaces,
    //		are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    return new ibm_ilog.graphlayout.random.RandomLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the customization interfaces, are also copied.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the drawing
    //		of the graph to fit (exactly or approximately) a user-defined region
    //		(a rectangle) or a user-defined manager view.
    
    return true; // Boolean
  },

  supportsRandomGenerator : function()
  {
    // summary:
    //		Indicates that this layout class uses randomly generated numbers
    //		that can be initialized with a user-defined seed value. 
    // description:
    //		Indicates that this layout class uses randomly generated numbers
    //		that can be initialized with a user-defined seed value. 
    //		When you perform the layout several times on the same graph and use
    //		the same user-defined seed value, you obtain the same drawing of the
    //		graph. If you want different drawings each time you perform the
    //		layout, you should modify the seed value and call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setUseSeedValueForRandomGenerator()</code>
    //		with a <code>true</code> argument.
    
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.random.RandomLayout,
{
  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.random.RandomLayout;
    if(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._fields_init)
      ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._fields_init(c);
    
    c.STRAIGHT_LINE_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.NO_RESHAPE_STYLE;
  }
  
}
);

ibm_ilog.graphlayout.random.RandomLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: false },
    { name: 'seedValueForRandomGenerator', defaultValue: 0 },
    { name: 'useSeedValueForRandomGenerator', defaultValue: false }
  ];
  var baseProperties = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ibm_ilog.graphlayout.random.RandomLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getNodeProperties();
};

ibm_ilog.graphlayout.random.RandomLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.random.RandomLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.random.RandomLayout");});
require(["ibm_ilog/graphlayout/random/RandomLayout"]);

},
'ibm_ilog*graphlayout/layer_random':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/random/RandomLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.layer_random", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.layer_random');


 builder delete end */
// The RandomLayout class will pull out the rest of classes
// required in the right order

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.random.RandomLayout');


 builder delete end */

return dojo.getObject("ibm_ilog.graphlayout.layer_random");});
require(["ibm_ilog/graphlayout/layer_random"]);

}}});

define([], 1);
